///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ASoundEditorForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ValEdit, StdCtrls, KOLFileInString, KOLTextFileInString,
  Buttons;

type
  TASoundEditorF = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    OkBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    CacelBut: TButton;
    UpBut: TBitBtn;
    DownBut: TBitBtn;
    ToNumerBut: TBitBtn;
    procedure OkButClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    procedure LoadMZ(Sender: TObject);
    function SaveMZ(Sender: TObject) : boolean;
    procedure SaveButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure CacelButClick(Sender: TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure UpButClick(Sender: TObject);
    procedure DownButClick(Sender: TObject);
    procedure ToNumerButClick(Sender: TObject);
  private
    { Private declarations }
    Function MakeShablon (Sender : TObject) : byte;
    Function CheckCode(Sender : TObject; const Code : string) : boolean;
    Procedure MoveElement (Sender : TObject; MoveTo : integer);
    procedure RefreshBatoni(Sender: TObject);
  public
    { Public declarations }
    InputStr : string;
    OutputStr : string;
    ModRes : byte;
  end;

var
  ASoundEditorF: TASoundEditorF;

implementation
uses initer, MySys, ShablonimForm, QskFnForm, CheckShablForm;

const
ArrCapac = 1000;

type
  ASoundRec = record
    StrFile : string;
    IntUnknown1 : integer;
    StrText : string;
    StrCode : string;
  end;

var
  TheStr : String;
  ASoundRecs : array[1..ArrCapac] of ASoundRec;
  NumRecs, RecNum : integer;
  MZLoaded : boolean;

{$R *.dfm}

Procedure LoadASoundStr(const Str : string);
var
  I : integer;
  TempStr, BufSt, BufSt2 : string;
begin
  //     .
  NumRecs := 0;   // 
  TempStr := Str;  //   
  I := 0;  //
  //  ...
  ASoundEditorF.MaskiBox.Items.Clear;
  ASoundEditorF.FilesBox.Items.Clear;

  If Length(TempStr) <> 0 then begin
    //    ...
    repeat
      I := I+1;
      BufSt := OtkusitPodPole(@TempStr);
      // .      ...

      //TEXT. File.
      BufSt2 := OtkusitPodPole(@BufSt);
      ASoundRecs[I].StrFile := PzDbStrToStr(BufSt2);

      //UnsLong. Unknown1.
      BufSt2 := OtkusitPodPole(@BufSt);
      ASoundRecs[I].IntUnknown1 := _4byteStrToUnsLong(BufSt2);

      //TEXT. Text.
      BufSt2 := OtkusitPodPole(@BufSt);
      ASoundRecs[I].StrText := PzDbStrToStr(BufSt2);

      //TEXT. Code.
      BufSt2 := OtkusitPodPole(@BufSt);
      ASoundRecs[I].StrCode := PzDbStrToStr(BufSt2);

      NumRecs := I; //    .

    until Length(TempStr) = 0;

    // ...
    For I := 1 to NumRecs do begin
      ASoundEditorF.MaskiBox.Items.Add(ASoundRecs[I].StrCode);
      ASoundEditorF.FilesBox.Items.Add(IntToStr(I)+'   '+ASoundRecs[I].StrText);
    end;

  end;

end;

Function SaveASoundStr : string;
var
  I : integer;
  TempStr, BufSt, BufSt2, BufSt3 : string;
begin
  //     .
  
  BufSt := '';

  If NumRecs <> 0 then begin
    //   ...
    For I := 1 to NumRecs do begin
      BufSt2 := '';

      //TEXT. File.
      BufSt3 := StrToPzDbStr2(ASoundRecs[I].StrFile);
      BufSt2 := AddPodPole(BufSt2,BufSt3,1);

      //UnsLong. Unknown1.
      BufSt3 := UnsLongTo4byteStr(ASoundRecs[I].IntUnknown1);
      BufSt2 := AddPodPole(BufSt2,BufSt3,2);

      //TEXT. Text.
      BufSt3 := StrToPzDbStr2(ASoundRecs[I].StrText);
      BufSt2 := AddPodPole(BufSt2,BufSt3,3);

      //TEXT. Code.
      BufSt3 := StrToPzDbStr2(ASoundRecs[I].StrCode);
      BufSt2 := AddPodPole(BufSt2,BufSt3,4);

      //       .
      BufSt := AddPodPole(BufSt,BufSt2,1);
    end;
  end;
  Result := BufSt;
end;

procedure TASoundEditorF.OkButClick(Sender: TObject);
var
  AllOk : boolean;
begin
  AllOk := true;

  //  ...
  If MZLoaded = true then begin
    //    ,   ...
    If SaveMZ(Sender) = false then begin
      AllOk := false;
      If MessageBox(Handle,'      - .  ?','!!!',MB_ICONWARNING or MB_YESNO) = ID_YES then begin
        //    ...
        AllOk := true;
      end;
    end;
  end;

  If AllOk = true then begin
    Close;
    ModRes := 1;
  end;  
end;

procedure TASoundEditorF.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //  .  .
  {If MZLoaded = true then begin
    //    ,   ...
    SaveMZ(Sender);
  end;}

  If ModRes = 1 then begin
    // 
    OutputStr := SaveASoundStr;
  end
  else begin
    //,  .
    OutputStr := 'NIL';
  end;
end;

procedure TASoundEditorF.FormShow(Sender: TObject);
begin
  // .   ...
  ModRes := 0;
  MaskiBox.Clear;
  FilesBox.Clear;
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';

  //"" ...
  LoadASoundStr(InputStr);

  MZLoaded := false;    //  ,     ...
  //    1 ,   ...
  If NumRecs > 0 then begin
    MaskiBox.ItemIndex := 0;
    MaskiBoxClick(Sender);
  end;

  //  .
  RefreshBatoni(Sender);  
end;

procedure TASoundEditorF.MaskiBoxClick(Sender: TObject);
begin
  {If MZLoaded = true then begin
    //    ,   ...
    SaveMZ(Sender);
  end;}
  //  
  RecNum := MaskiBox.ItemIndex+1;
  FilesBox.ItemIndex := MaskiBox.ItemIndex;
  // "" 
  LoadMZ(Sender);

  //  .
  RefreshBatoni(Sender); 
end;

procedure TASoundEditorF.FilesBoxClick(Sender: TObject);
begin
  {If MZLoaded = true then begin
    //    ,   ...
    SaveMZ(Sender);
  end;}
  //  
  RecNum := FilesBox.ItemIndex+1;
  MaskiBox.ItemIndex := FilesBox.ItemIndex;
  // "" 
  LoadMZ(Sender);

  //  .
  RefreshBatoni(Sender); 
end;

procedure TASoundEditorF.LoadMZ(Sender: TObject);
begin
  //      .
  ValuesEd.Cells[1,1] := ASoundRecs[RecNum].StrFile;
  ValuesEd.Cells[1,2] := IntToStr(ASoundRecs[RecNum].IntUnknown1);
  ValuesEd.Cells[1,3] := ASoundRecs[RecNum].StrText;
  ValuesEd.Cells[1,4] := ASoundRecs[RecNum].StrCode;

  MZLoaded := true;  // .
end;

function TASoundEditorF.SaveMZ(Sender: TObject) : boolean;
begin
  //    .
  //  ...
  if CheckStrInt(ValuesEd.Cells[1,2]) = false then begin
    ValuesEd.Selection := SelGridRect(1,2);
    Beep;
    MessageBox(Handle,'    .','',MB_ICONERROR or MB_OK);
    Result := false;
  end
  else begin
    ASoundRecs[RecNum].StrFile := ValuesEd.Cells[1,1];
    ASoundRecs[RecNum].IntUnknown1 := StrToInt(ValuesEd.Cells[1,2]);
    ASoundRecs[RecNum].StrText := ValuesEd.Cells[1,3];
    ASoundRecs[RecNum].StrCode := ValuesEd.Cells[1,4];
    result := true;
  end;  
end;

procedure TASoundEditorF.SaveButClick(Sender: TObject);
begin
  If SaveMZ(Sender) = true then begin
    //   , 
    //     ...
    MaskiBox.Items.Strings[RecNum-1] := ValuesEd.Cells[1,4];
    FilesBox.Items.Strings[RecNum-1] := IntToStr(RecNum)+'   '+ASoundRecs[RecNum].StrText;
    //   ,   .
    MaskiBox.ItemIndex := RecNum-1;
    FilesBox.ItemIndex := RecNum-1;
  end;
end;

procedure TASoundEditorF.CreateButClick(Sender: TObject);
var
  AllOk, ind1, ind2 : boolean;
  Code, TempStr : string;
  TextFil1 : TTextFileInString;

begin
  AllOk := true;
  {If MZLoaded = true then begin
    //    ,   ...
    If SaveMZ(Sender) = false then begin
      AllOk := false;
      If MessageBox(Handle,'      - .    ?','!!!',MB_ICONWARNING or MB_YESNO) = ID_YES then begin
        //    ...
        AllOk := true;
      end;
    end;;
  end;}

  If AllOk = true then begin
    // ,     -   .
    // Code,    ...
    ind1 := false;
    repeat
      AskFnForm.QuestionDial := '   Code   :';
      AskFnForm.ShowModal;
      if AskFnForm.ModalResult = MrOk then begin
        Code := AskFnForm.AnswerDial;
        if CheckCode(Sender,Code) = true then begin
          //  .

          //   .
          ShablonimF.ShablsPath := Path+'shablons\ASounds\';
          CheckShablF.ShowModal;
          //     
          // -  .

          If CheckShablF.ModalResult = mrOk then begin
            //ShowMessage(ShablPath);
            // ...

            // -   ,  ,
            //      ...
            NumRecs := NumRecs+1;

            TextFil1 := TTextFileInString.Init;
            TextFil1.Load(ShablonimF.ShablPath);
            TextFil1.Cursor := 1;
            //...
            ASoundRecs[NumRecs].StrFile := TextFil1.CurReadLn;
            ASoundRecs[NumRecs].IntUnknown1 := StrToInt(TextFil1.CurReadLn);
            ASoundRecs[NumRecs].StrText := TextFil1.CurReadLn;
            ASoundRecs[NumRecs].StrCode := Code;  //  ,   .
            TextFil1.Free;

            // .     ,  ,
            //    .

            MaskiBox.Clear;    //  -   ...
            FilesBox.Clear;
            MZLoaded := false;
            RefreshBatoni(Sender);

            TempStr := SaveASoundStr;  //  , ..   
            // !
            LoadASoundStr(TempStr);  // ...

            MaskiBox.ItemIndex := NumRecs-1;
            MaskiBoxClick(Sender);

            //  1...
            ind1 := true;
          end
          else begin
            // ...
            //  1...
            ind1 := true;
          end;
        end
        else begin
          //  .
          MessageDLG('!      !   !',mtError,[mbOk],0);
        end;
      end
      else begin
        //     
        ind1 := true;
      end;
    until ind1 = true;
  end;

  //  .
  RefreshBatoni(Sender);
end;

procedure TASoundEditorF.RefreshBatoni(Sender: TObject);
begin
  //   ...
  If MZLoaded = false then begin
    ZashablonitBut.Enabled := false;
    SaveBut.Enabled := false;
    DeleteBut.Enabled := false;
    UpBut.Enabled := false;
    DownBut.Enabled := false;
    ToNumerBut.Enabled := false;
  end
  else begin
    ZashablonitBut.Enabled := true;
    SaveBut.Enabled := true;
    DeleteBut.Enabled := true;

    If RecNum = 1 then begin
      //   .
      UpBut.Enabled := false;
    end
    else begin
      //   .
      UpBut.Enabled := true;
    end;

    If RecNum = NumRecs then begin
      //   .
      DownBut.Enabled := false;
    end
    else begin
      //   .
      DownBut.Enabled := true;
    end;

    ToNumerBut.Enabled := true;

  end;
end;

procedure TASoundEditorF.DeleteButClick(Sender: TObject);
var
  I : integer;
  TempStr : string;
  
begin
  If MessageBox(Handle,'???',' ...',MB_ICONQUESTION or MB_YESNO) = ID_YES then begin
    //        .
    //  ,    ,   
    //        (   ),
    //       (       ).

    If RecNum <> NumRecs then begin
      //   .
      For I := RecNum to NumRecs-1 do begin
        // ...
        ASoundRecs[I].StrFile := ASoundRecs[I+1].StrFile;
        ASoundRecs[I].IntUnknown1 := ASoundRecs[I+1].IntUnknown1;
        ASoundRecs[I].StrText := ASoundRecs[I+1].StrText;
        ASoundRecs[I].StrCode := ASoundRecs[I+1].StrCode;
      end;
    end;

    // -     .  . 
    //   .
    NumRecs := NumRecs-1;

    // .     ,  ,
    //    .
    I := RecNum-1;     //    ...
    If I = 0 then I := 1;  //    -   .

    MaskiBox.Clear;    //  -   ...
    FilesBox.Clear;
    MZLoaded := false;
    RefreshBatoni(Sender);

    TempStr := SaveASoundStr;  //  , ..   
    // !
    LoadASoundStr(TempStr);  // ...

    //     ,     ...
    If NumRecs <> 0 then begin
      //  ...
      MaskiBox.ItemIndex := I-1;
      MaskiBoxClick(Sender);
    end
    else begin
      // ...

    end;

  end;
  //  .
  RefreshBatoni(Sender);
end;

procedure TASoundEditorF.CacelButClick(Sender: TObject);
begin
  ModRes := 0;
  Close;
end;

Function TASoundEditorF.MakeShablon (Sender : TObject) : byte;
var
  Fil1 : TTextFileInString;
  AllOk : boolean;

begin
  //      .

  AllOk := true;
  //  ...     ...
  If SaveMZ(Sender) = false then begin
    AllOk := false;
    If MessageBox(Handle,'      - .  ? (    )','!!!',MB_ICONWARNING or MB_YESNO) = ID_YES then begin
      //    ...
      AllOk := true;
    end;
  end;

  //  ...
  Fil1 := TTextFileInString.Init;
  Fil1.MakNewFile;

  //    ...
  Fil1.AddStr(ASoundRecs[RecNum].StrFile);
  Fil1.AddStr(IntToStr(ASoundRecs[RecNum].IntUnknown1));
  Fil1.AddStr(ASoundRecs[RecNum].StrText);
  Fil1.AddStr(ASoundRecs[RecNum].StrCode);

  //   ...

  ShablonimF.ShablsPath := Path+'shablons\ASounds\';
  ShablonimF.ShowModal;
  If ShablonimF.ModalResult = mrOk then begin
    //  ..
    Fil1.Save(ShablonimF.ShablPath);
  end;

  Result := 1;
end;

procedure TASoundEditorF.ZashablonitButClick(Sender: TObject);
begin
  MakeShablon(Sender);
end;

Function TASoundEditorF.CheckCode(Sender : TObject; const Code : string) : boolean;
var
  I : integer;
begin
  result := true;
  //   .
  For I := 1 to NumRecs do begin
    If ASoundRecs[I].StrCode = Code then begin
      //  . , .   ...
      Result := false;
      //   ...
      Exit //    .
    end;
  end;
end;

Procedure TASoundEditorF.MoveElement (Sender : TObject; MoveTo : integer);
var
  I : integer;
  TempStr : string;
begin
  //     
  // .

  //  -  ( ""   )
  //  .

  I := NumRecs+1;  //"" ...
  ASoundRecs[I].StrFile := ASoundRecs[RecNum].StrFile;
  ASoundRecs[I].IntUnknown1 := ASoundRecs[RecNum].IntUnknown1;
  ASoundRecs[I].StrText := ASoundRecs[RecNum].StrText;
  ASoundRecs[I].StrCode := ASoundRecs[RecNum].StrCode;

  //  ()       ...
  ASoundRecs[RecNum].StrFile := ASoundRecs[MoveTo].StrFile;
  ASoundRecs[RecNum].IntUnknown1 := ASoundRecs[MoveTo].IntUnknown1;
  ASoundRecs[RecNum].StrText := ASoundRecs[MoveTo].StrText;
  ASoundRecs[RecNum].StrCode := ASoundRecs[MoveTo].StrCode;

  // -       ...
  ASoundRecs[MoveTo].StrFile := ASoundRecs[I].StrFile;
  ASoundRecs[MoveTo].IntUnknown1 := ASoundRecs[I].IntUnknown1;
  ASoundRecs[MoveTo].StrText := ASoundRecs[I].StrText;
  ASoundRecs[MoveTo].StrCode := ASoundRecs[I].StrCode;

  // .  -   ,    ...

  MaskiBox.Clear;    //  -   ...
  FilesBox.Clear;
  MZLoaded := false;
  RefreshBatoni(Sender);

  TempStr := SaveASoundStr;  //  , ..   
  // !
  LoadASoundStr(TempStr);  // ...

  MaskiBox.ItemIndex := MoveTo-1;
  MaskiBoxClick(Sender);
end;

procedure TASoundEditorF.UpButClick(Sender: TObject);
begin
  //       ...
  MoveElement(Sender,RecNum-1);
end;

procedure TASoundEditorF.DownButClick(Sender: TObject);
begin
  //       ...
  MoveElement(Sender,RecNum+1);
end;

procedure TASoundEditorF.ToNumerButClick(Sender: TObject);
var
  MoveTo : integer;
  Ind1 : boolean;

begin
  //    
  //  ...

  // ...
  AskFnForm.QuestionDial := '     ?';
  ind1 := false;
  repeat
    AskFnForm.ShowModal;
    If AskFnForm.ModalResult = mrOK then begin
      //  ...
      If CheckStrInt(AskFnForm.AnswerDial) = true then begin
        //  ...
        MoveTo := StrToInt(AskFnForm.AnswerDial);
        If (MoveTo >= 1) and (MoveTo <= NumRecs) and (MoveTo <> RecNum) then begin
          //  ...
          //   ...
          MoveElement(Sender,MoveTo);

          //      ...
          ind1 := true;
        end
        else begin
          //    ,  ...
          MessageBox(Handle,PChar('      1  '+IntToStr(NumRecs)+',      '+IntToStr(RecNum)+'.'),'!',MB_ICONERROR or MB_OK);
        end;
      end
      else begin
        // ,   .
        MessageBox(Handle,'    , ""   ;)','  !',MB_ICONERROR or MB_OK);
      end;
    end
    else begin
      // ,    ""...
      ind1 := true;  //  ...
    end;
  until ind1 = true;  //,     ,
                      //     .
end;

end.
