///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit BaseOptForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, PZed, MySys;

type
  TBaseOptF = class(TForm)
    OkBut: TButton;
    CancelBut: TButton;
    DbLmpResIshEd: TEdit;
    DbResEd: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Browse1But: TButton;
    Browse4But: TButton;
    Label3: TLabel;
    DbLmpResEd: TEdit;
    Browse2But: TButton;
    Label4: TLabel;
    DbResIshEd: TEdit;
    Browse3But: TButton;
    OFD1: TOpenDialog;
    procedure Browse1ButClick(Sender: TObject);
    procedure Browse4ButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OkButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure Browse3ButClick(Sender: TObject);
    procedure Browse2ButClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    DbResEd_PBSost : boolean;
    DbLmpResEd_PBSost : boolean;
    DbResIshEd_PBSost : boolean;
    DbLmpResIshEd_PBSost : boolean;
    Browse1But_PBSost : boolean;
    Browse2But_PBSost : boolean;
    Browse3But_PBSost : boolean;
    Browse4But_PBSost : boolean;
    OkBut_PBSost : boolean;
    CancelBut_PBSost : boolean;
    CanClose : boolean;
    procedure BlockForm;
    procedure UnBlockForm;
  public
    { Public declarations }
  end;

var
  BaseOptF: TBaseOptF;

implementation

uses BrowseDirForm, KOL;

{$R *.DFM}

procedure TBaseOptF.Browse1ButClick(Sender: TObject);
begin
  //   -    ...

  // ...
  If DirectoryExists(ExtractFilePath(DbResEd.Text)) = true then begin
    OFD1.InitialDir := ExtractFilePath(DbResEd.Text);
    OFD1.FileName := ExtractFileName(DbResEd.Text);
  end
  else begin
    OFD1.InitialDir := DefalDir;
  end;

  //        -  .
  If OFD1.Execute = true then begin
    DbResEd.Text := OFD1.FileName;
  end;
  
end;

procedure TBaseOptF.Browse4ButClick(Sender: TObject);
var
  ODD1 : POpenDirDialog;
begin
  //   -    ...

  // ...
  ODD1 := NewOpenDirDialog(' ',[]);
  If DirectoryExists(DbLmpResIshEd.Text) = true then begin
    ODD1.InitialPath := DbLmpResIshEd.Text;
  end
  else begin
    ODD1.InitialPath := DefalDir;
  end;
  ODD1.WndOwner := Application.Handle;  // " "...

  //        -  .
  If ODD1.Execute = true then begin
    DbLmpResIshEd.Text := AddLastSlash(ODD1.Path);
  end;

  //  ...
  ODD1.Free;
end;

procedure TBaseOptF.FormShow(Sender: TObject);
begin
  //      ...
  DbResEd.Text := DatabaseResPath;
  DbLmpResEd.Text := DatabaselmpResPath;
  DbResIshEd.Text := DatabaseResIsh;
  DbLmpResIshEd.Text := DatabaselmpResIsh;

  CanClose := false;  //   ...
end;

procedure TBaseOptF.OkButClick(Sender: TObject);
begin
  //       ...

  //  -   ...
  DatabaseResPath := DbResEd.Text;
  DatabaselmpResPath := DbLmpResEd.Text;
  DatabaseResIsh := DbResIshEd.Text;
  DatabaselmpResIsh := DbLmpResIshEd.Text;

  //     ...
  AnIniFil.Load(IniFilPath);  // .
  AnIniFil.WriteString('MainSettings','DatabaseResPath',DatabaseResPath);
  AnIniFil.WriteString('MainSettings','DatabaselmpResPath',DatabaselmpResPath);
  AnIniFil.WriteString('MainSettings','DatabaseResIsh',DatabaseResIsh);
  AnIniFil.WriteString('MainSettings','DatabaselmpResIsh',DatabaselmpResIsh);
  AnIniFil.Save(IniFilPath);  // .    :)

  //  .
  CanClose := true;
  ModalResult := MrOk;
  CloseLishneeBase;
end;

procedure TBaseOptF.CancelButClick(Sender: TObject);
begin
  CanClose := true;
  ModalResult := MrCancel;
end;

procedure TBaseOptF.Browse3ButClick(Sender: TObject);
var
  ODD1 : POpenDirDialog;
begin
  //   -    ...

  // ...
  ODD1 := NewOpenDirDialog(' ',[]);
  If DirectoryExists(DbResIshEd.Text) = true then begin
    ODD1.InitialPath := DbResIshEd.Text;
  end
  else begin
    ODD1.InitialPath := DefalDir;
  end;
  ODD1.WndOwner := Application.Handle;  // " "...

  //        -  .
  If ODD1.Execute = true then begin
    DbResIshEd.Text := AddLastSlash(ODD1.Path);
  end;

  //  ...
  ODD1.Free;
end;

procedure TBaseOptF.Browse2ButClick(Sender: TObject);
begin
  //   -    ...

  // ...
  If DirectoryExists(ExtractFilePath(DbLmpResEd.Text)) = true then begin
    OFD1.InitialDir := ExtractFilePath(DbLmpResEd.Text);
    OFD1.FileName := ExtractFileName(DbLmpResEd.Text);
  end
  else begin
    OFD1.InitialDir := DefalDir;
  end;

  //        -  .
  If OFD1.Execute = true then begin
    DbLmpResEd.Text := OFD1.FileName;
  end;
end;

procedure TBaseOptF.BlockForm;
begin
  //   ...

  // ...
  DbResEd_PBSost := DbResEd.Enabled;
  DbLmpResEd_PBSost := DbLmpResEd.Enabled;
  DbResIshEd_PBSost := DbResIshEd.Enabled;
  DbLmpResIshEd_PBSost := DbLmpResIshEd.Enabled;
  Browse1But_PBSost := Browse1But.Enabled;
  Browse2But_PBSost := Browse2But.Enabled;
  Browse3But_PBSost := Browse3But.Enabled;
  Browse4But_PBSost := Browse4But.Enabled;
  OkBut_PBSost := OkBut.Enabled;
  CancelBut_PBSost := CancelBut.Enabled;

  // ...
  DbResEd.Enabled := false;
  DbLmpResEd.Enabled := false;
  DbResIshEd.Enabled := false;
  DbLmpResIshEd.Enabled := false;
  Browse1But.Enabled := false;
  Browse2But.Enabled := false;
  Browse3But.Enabled := false;
  Browse4But.Enabled := false;
  OkBut.Enabled := false;
  CancelBut.Enabled := false;
end;


procedure TBaseOptF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If CanClose = true then begin
    Action := Forms.caHide;   //Forms -      KOL.
  end
  else begin
    Action := Forms.caNone;
  end;  
end;

procedure TBaseOptF.UnBlockForm;
begin
  //  -    
  DbResEd.Enabled := DbResEd_PBSost;
  DbLmpResEd.Enabled := DbLmpResEd_PBSost;
  DbResIshEd.Enabled := DbResIshEd_PBSost;
  DbLmpResIshEd.Enabled := DbLmpResIshEd_PBSost;
  Browse1But.Enabled := Browse1But_PBSost;
  Browse2But.Enabled := Browse2But_PBSost;
  Browse3But.Enabled := Browse3But_PBSost;
  Browse4But.Enabled := Browse4But_PBSost;
  OkBut.Enabled := OkBut_PBSost;
  CancelBut.Enabled := CancelBut_PBSost;
end;

procedure TBaseOptF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //ShowMessage('');   //      watch-,  .

  //       :).
  If Key = #13 then begin
    //Enter
    OkButClick(Sender);
    //    ...
    Key := #0;
  end;

  If Key = #27 then begin
    //Escape
    CancelButClick(Sender);
    //    ...
    Key := #0;
  end;
end;

end.
