///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit Initer;

/////////////////////////////////////////////
//                //
/////////////////////////////////////////////

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry, Menus, ExtCtrls, ComCtrls, ToolWin, CopyFileUnit,
  mySys, ShowProcessForm, KOLFileInString, KOL, KOLAnIniFile, KOLForPaths,
  KOLVersionInfo, KOLClearDir, VerInfoTxtFormat;

const
  Zagolov = '    ';
  NZap = 1000;
  TxtEdDlgDefFiltList = '*|    :)'+'|*.*|   '+'|allod*|'+'|armor*|'+'|briefing*|'+'|camphelp*| '+'|instr*|'+'|litem*|  '+'|map.txt| '+'|material*|'+'|matshort*|  '+'|modifier*|'+'|perk*|'+'|pers*| '+'|qitem*|'+'|quest*| '+'|questitem*| '+'|say*|  '+'|spell*|'+'|string*|'+'|tip*| '+'|tutor*|  '+'|tutorial*| '+'|unit*| '+'|weapon*|'+'|zone*| '+'|*.res|'+'|*.mq|-';
  IniConfFormatVer = 1;
  EiEdit_AppName = 'Eiedit';
  EiEdit_CopyrightStr = 'Copyright  2002-2007 Gipat Group';
  EiEdit_CraftedBy_list = 'Sagrer';
  EiEdit_DevelsContacts = 'www.GipatGroup.org';


type
  ByteFile = File of Byte;
  TZapisBaziPz = class (TObject)
  //      .
    ZapisString : ANSIString;
    FieldsString : ANSIString;
    Siz : integer;
    FieldOv : integer;
    SizFieldOv : integer;
    FieldsCreated : boolean;
    ZapisCreated : boolean;
    SizFieldOtv : integer;
    Constructor Init;
    Procedure LoadZap(const ZapSt : ANSIString; sz : integer);
    Procedure BuildZap;
    Function GetField(const FieldNum : integer) : ANSIString;
    Procedure ReWriteField(const FieldNum, sizSt : integer; St: ANSIString);
    Procedure CreateFields(const FieldNum : integer; NomPoley : StoIntegerov);
  end;
  MaskFileArr = array[1..NZap,1..2] of string;

var
  //String
  Path, PzPath, PzResPath, PzCdPath, KodeOpt, DefalDir,
  databasedir, databaselmpdir, ishdir, ishlmpdir, IniFilPath,
  AiinfoResPath, DatabaseResPath, DatabaselmpResPath, FiguresResPath,
  GfxResPath, MaterialsResPath, MenusResPath, OutroResPath,
  RedressResPath, SfxResPath, SpeechResPath, TextsResPath,
  TextslmpResPath, TexturesResPath, DatabaseResIsh, DatabaselmpResIsh,
  TextsEdStart, TxtEdDlgFiltList : string;
  //Integer
  MfHeight, MfWidth, MfTop, MfLeft, MfWstate, TxtEdDlgCritSiz,
  TxtEdDlgActFilt : integer;
  //boolean
  ResursFormClosed, PrintsDbR1FClosed, PrintsDbR2FClosed, PrintsDbR3FClosed,
  LmpLeversFClosed, LeversFClosed, UncAskFSaved,
  SinglPrintsDbR1FClosed, SinglPrintsDbR2FClosed,
  SinglPrintsDbR3FClosed, SinglItemsIdbR1FClosed,
  UncAskFLetChangSiz, ItemsIdbR1FClosed, SinglItemsIdbR2FClosed,
  ItemsIdbR2FClosed, SinglItemsIdbR3FClosed,
  ItemsIdbR3FClosed, SinglItemsIdbR4FClosed,
  ItemsIdbR4FClosed, SinglItemsIdbR5FClosed,
  ItemsIdbR5FClosed, SinglItemsIdbR6FClosed,
  ItemsIdbR6FClosed, SinglPerksPdbR1FClosed,
  PerksPdbR1FClosed, SinglPerksPdbR2FClosed,
  PerksPdbR2FClosed, SinglQuestsQdbR1FClosed,
  SinglQuestsQdbR2FClosed,
  UnitsUdbR1FClosed, SinglUnitsUdbR1FClosed,
  UnitsUdbR2FClosed, SinglUnitsUdbR2FClosed,
  UnitsUdbR3FClosed, SinglUnitsUdbR3FClosed,
  UnitsUdbR4FClosed, SinglUnitsUdbR4FClosed,
  SpellsSdbR1FClosed, SinglSpellsSdbR1FClosed,
  SpellsSdbR2FClosed, SinglSpellsSdbR2FClosed,
  SpellsSdbR3FClosed, SinglSpellsSdbR3FClosed,
  SpellsSdbR4FClosed, SinglSpellsSdbR4FClosed,
  SpellsSdbR5FClosed, SinglSpellsSdbR5FClosed,
  SinglAcksDbR1FClosed, SinglAcksDbR2FClosed,
  SinglAcksDbR3FClosed, OptStandRes, TxtEdDlg1Click,
  TxtEdDlgUseCritSiz, TxtEdDlgWordWrap : boolean;

  //... ,      
  //....      
  //     ...
  CPCResult : RCPCResult;
  PzDbStrRec : RPzDbStrRec;
  Registr : TRegistry;
  AnIniFil : TAnIniFile;
  VitInfo : TVerInfoTxtFormat;


Procedure OpenProgKey;
Procedure OpenPZPathKey;
Procedure OpenPZGSKey;
Procedure CloseTheKey;
Procedure InitPzKey;
Procedure InitProgKey;
Function CopDir(PathIn, DestIn : string; bar : TProgressBar) : integer;
Function StrWinDos (str1 : string) : string;
Procedure UnPackResurs(const pathfill, fill : string);
Procedure PackResurs(const pathdir : string);
Function RaspakBase(const BasFile, PathIshDir : string) : integer;
Function GetDlBig (const b1, b2, b3, b4 : byte) : integer;
Function GetDlSmall(const b1 : byte) : integer;
Function ZapakBase(const PathIshDir, PathConDir : string) : integer;
Function MakeDlBig(const int : integer) : ChetireBaita;
Function MakeDlSmall(const int : integer) : byte;
Procedure VipravitFaili(DirPath : string);
Function OtkusitPodPole(Point1 : PointToStr) : string;
Function AddPodPole(const Str, AddStr : string; zagol : integer): string;
Function UnsLongToShopInfo(const Int : integer) : string;
Function GetMagazChislo(const num : integer) : integer;
Function CheckShopInfo(const Str : string) : boolean;
Function ShopInfoToUnsLong(const Str : string) : integer;
Function GetUnkStr(const Unk : string; UnkSiz : integer) : string;
Function ListToStr(const ListStr : string) : string;
Function CheckList (const Str : string) : boolean;
Function ListBezProbelov(const Str : string) : string;
Function StrToList(const Str : string) : string;
Function SelectValue(const List : string) : string;
Function SelectValueEx(const List : string; Idx : integer) : string;
Function _4bTEXTListToStr(const ListStr : string) : string;
Function ListTo4bTEXTStr(const Str : string) : string;
Function CheckList4bTEXT(const Str : string) : boolean;
Function EditASound(const Str : string) : string;
Function GetASoundStr(const Str : string) : string;
Function AddDirToRes(const ResFile, DirPath : string) : string;
Function UnPackResToDir(const ResFile, DirPath : string) : string;
Function ModalAddDirToRes(const ResFile, DirPath : string) : string;
Function ModalUnPackResToDir(const ResFile, DirPath : string) : string;
Function GetExtensDirName(const FileName : string) : string;
Function GetExtensFileName(const DirName : string) : string;
Function OptimizeRes(const ResFile : string) : string;
Function ModalOptimizeRes(const ResFile : string) : string;
Function SimvCountInStr(const Str : string; Simv : Char) : integer;
Function UnPackResDialog(const FileName : string) : string;
Function PackResDialog(const DirName : string) : string;
Function SortStringFileArray(const TheArray : MaskFileArr) : MaskFileArr;


implementation
uses
  PzEd, OptiF, ValueSelectorForm, ASoundEditorForm, ResbuildForm,
  RbPackOptForm, RBUnPackOptForm;

var
  SRec : TSearchRec;

Function StrWinDos (str1 : string) : string;
var
  I : integer;
  ch : char;
  byt1, byt2 : byte;
  strOut : string;
begin
  I := 0;
  strOut :='';
  repeat
    I := I+1;
    if str1[I] <> #0 then begin
      ch := str1[I];
      byt1 := byte(ch);
      byt2 := ConvertWinDos(byt1);
      Ch := char(byt2);
      strOut := strOut+Ch;
    end;
  until str1[I] = #0;
  result := strOut;
end;

Procedure InitPzKey;
begin
  Registr.RootKey:=HKEY_CURRENT_USER;
end;

Procedure InitProgKey;
begin
  Registr.RootKey:=HKEY_LOCAL_MACHINE;
end;

Procedure OpenProgKey;
begin
  InitProgKey;
  registr.OpenKey('\Software\EiEditor',false);
end;

Procedure OpenPZPathKey;
begin
  InitPzKey;
  registr.OpenKey('\Software\Nival Interactive\EvilIslands\Path Settings',false);
end;

Procedure OpenPZGSKey;
begin
  InitPzKey;
  registr.OpenKey('\SOFTWARE\Nival Interactive\EvilIslands\Game Specific Settings',false);
end;

Procedure CloseTheKey;
begin
  registr.CloseKey;
end;

Procedure PackResurs(const pathdir : string);
var
  f1 : textfile;
  str1, str2, str4, str5, pathDOdir, buf, pat, buf2, rezfil : string;
  I, j : integer;
begin
  // ""
  I := 0;
  PathDOdir := '';
  repeat
    pat := '';
    repeat
      buf := '';
      I := I+1;
      buf := pathdir[I];
      pat := pat+buf;
    until (buf = '\') or (buf = #0);
    if pathdir[I+1] =#0 then buf := #0;
    if (pathdir[I+1] <> #0) and (pat <> #0) then PathDOdir := pathDOdir+pat;
    if pathdir[I+1] =#0 then begin  //  
      J := 0;
      rezfil := '';
      repeat
        J := J+1;
        buf2 := pat[J];
        if buf2 <> '\' then rezfil := rezfil+buf2;
      until buf2 = '\';
    end;
  until buf = #0;
  str4 := PChar(pathdir);
  str5 := PChar(pathDOdir);
  str1 := LongToShortPath(str4);
  str2 := LongToShortPath(str5);
  AssignFile(F1,pathDOdir+'packer.bat');
  Rewrite(F1);
  Writeln(F1,strWinDos('chdir '+str1));
  Writeln(F1,strWinDos(str2+'resbuild.exe a '+str2+rezfil+'.res *'));
  closefile(f1);
  WinExec(Pchar(pathDOdir+'packer.bat'), Sw_ShowNormal);
  MessageDLG(' .      '
  ,MtInformation,[mbOk],0);
end;

Procedure UnPackResurs(const pathfill, fill : string);
var
  f1 : textfile;
  str1, str2, str4, str5, dirnam, buf : string;
  I : integer;
begin
  AssignFile(F1,pathfill+'unpacker.bat');
  Rewrite(F1);
  dirnam := '';
  I := 0;
  repeat
    buf := '';
    I := I+1;
    buf := fill[I];
    if buf <> '.' then dirnam := dirnam+buf;
  until buf = '.';
  str4 := PChar(pathfill+dirnam);
  str5 := PChar(pathfill);
  str1 := LongToShortPath(str4);
  str2 := LongToShortPath(str5);
  Writeln(F1,strWinDos('chdir '+str1));
  Writeln(F1,strWinDos(str2+'resbuild.exe e '+str2+fill+' *'));
  closefile(f1);
  WinExec(Pchar(pathfill+'unpacker.bat'), Sw_ShowNormal);
  MessageDLG(' .      '
  ,MtInformation,[mbOk],0);
end;

Function CopDir(PathIn, DestIn : string; bar : TProgressBar) : integer;
var
  path, file1, readbuf, dest, from, fto : string;
  f1 : textfile;
  HaveSpace, NeedSpace : int64;

Procedure CreateList(path, dest2 : string);
var
  pathNew, OldNew, FoldFileNew : string;
  SRecNew : TSearchRec;
begin
  PathNew := path;
  findFirst(PathNew+'*.*',FaAnyFile,SRecNew);
  if DirectoryExists(pathNew+SRecNew.name) = true then foldfileNew := ' folder'
  else foldfileNew := ' file';
  if foldfilenew = ' folder' then begin
    if (SRecNew.name <> '.') and (SRecNew.name <> '..') then begin
      Writeln(f1,'MD');
      Writeln(f1,pathNew+SRecNew.name+'\');
      Writeln(f1,dest2+SRecNew.name+'\');
      CreateList(pathNew+SRecNew.name+'\',dest2+SRecNew.name+'\');
    end;
  end
  else begin
    if (SRecNew.name <> '.') and (SRecNew.name <> '..') then begin
      Writeln(f1,'Copy');
      Writeln(f1,pathNew+SRecNew.name);
      Writeln(f1,dest2+SRecNew.name);
    end;
  end;

  repeat
    oldNew := pathNew+SRecNew.name;
    FindNext(SRecNew);
    if DirectoryExists(pathNew+SRecNew.name) = true then foldfileNew := ' folder'
    else foldfileNew := ' file';
    if foldfilenew = ' folder' then begin
      if (SRecNew.name <> '.') and (SRecNew.name <> '..') then begin
        if oldNew <> pathNew+SRecNew.name then begin
          Writeln(f1,'MD');
          Writeln(f1,pathNew+SRecNew.name+'\');
          Writeln(f1,dest2+SRecNew.name+'\');
          CreateList(pathNew+SRecNew.name+'\',dest2+SRecNew.name+'\');
        end;
      end;
    end
    else begin
      if (SRecNew.name <> '.') and (SRecNew.name <> '..') then begin
        if oldNew <> pathNew+SRecNew.name then begin
          Writeln(f1,'Copy');
          Writeln(f1,pathNew+SRecNew.name);
          Writeln(f1,dest2+SRecNew.name);
        end;
      end;
    end;
  until oldNew = pathNew+SRecNew.name;

  FindClose(SRecNew);
end;

begin
  file1 := GetTempDir+'CopyList.lis';
  AssignFile(f1,file1);
  Rewrite(f1);
  path := PathIn;
  dest := DestIn;
  CreateList(path, dest);
  Write(f1,'end');
  CloseFile(f1);
  HaveSpace := DiskFree(GetDraNum(dest));
  AssignFile(f1,file1);
  Reset(f1);
  NeedSpace := 0;
  repeat
    Readln(f1,readbuf);
    if Readbuf <> 'end' then begin
      if readbuf = 'Copy' then begin
        Readln(f1,readbuf);
        from := readbuf;
        Readln(f1,readbuf);
        fto := readbuf;
        NeedSpace := NeedSpace+GetFileSize(fto);
      end;
    end;
  until readbuf = 'end';
  CloseFile(f1);
  If HaveSpace > NeedSpace then begin
    AssignFile(f1,file1);
    Reset(f1);
    repeat
      Readln(f1,readbuf);
      if Readbuf <> 'end' then begin
        if readbuf = 'MD' then begin
          Readln(f1,readbuf);
          Readln(f1,readbuf);
          MkDir(readbuf);
        end;
        if readbuf = 'Copy' then begin
          Readln(f1,readbuf);
          from := readbuf;
          Readln(f1,readbuf);
          fto := readbuf;
          VCLCopyFile(from,fto,true,true,bar);
        end;
      end;
    until readbuf = 'end';
    CloseFile(f1);
    result := 0;
  end  
  else begin
    MessageDLG('!.   '+IntToStr(NeedSpace-HaveSpace)+'   ',mtError,[mbOk],0);
    result := 1;
  end;  
end;

Function RaspakBase(const BasFile, PathIshDir : string) : integer;
var
  FoldNam1, foldnam2 : string;
  Fil1, Fil2 : TFileInString;
  buffer, buf1, buf2, buf3, buf4 : byte;
  kursor : int64;
  NumerRazd2, NumerRazd3, DL1, DL2, Dl3, numerator1,
  numerator2, numerator3, Sch1 : integer;

begin
  //   -.
  //    ...
  ShowProcessF.Show;
  ShowProcessF.InfoLab1.Caption := BasFile;
  ShowProcessF.InfoLab2.Caption := '    ...';
  ShowProcessF.PrBar.Position := 0;
  ShowProcessF.Refresh;
  //  ,   .
  FoldNam1 := GetFilePath(PathIshDir)+GetFileName(BasFile)+'\';
  If DirectoryExists(foldnam1) then ClearDir(Foldnam1,true);
  MkDir(FoldNam1);
  //       .
  Fil1 := TFileInString.Init;
  Fil1.Load(BasFile);
  //fil1.AddByte(199);
  //Fil1.Save(PathIshDir+GetFileName2(BasFile));
  //   ,    ...
  ShowProcessF.InfoLab2.Caption := '    ...';
  ShowProcessF.PrBar.Max := Fil1.Siz;
  ShowProcessF.refresh;
  //  ..
  Kursor := 0;
  Sch1 := 0;
  //   ...
  kursor := kursor+1;
  Sch1 := Sch1+1;
  buffer := byte(Fil1.FileString[kursor]);
  ShowProcessF.PrBar.Position := kursor;
  ShowProcessF.PrBar.Refresh;
  if buffer <> 0 then begin
    if buffer <> 1 then messageDLG('    <01>. ...',mtWarning,[mbOk],0);
    kursor := kursor+1;
    Sch1 := Sch1+1;
    buffer := byte(Fil1.FileString[kursor]);
    ShowProcessF.PrBar.Position := kursor;
    ShowProcessF.PrBar.Refresh;
    
    if chetnoe(buffer) then begin
      //  .
      DL1 := GetDLSmall(buffer);
    end
    else begin
      //  .
      buf1 := buffer;
      kursor := kursor+1;
      Sch1 := Sch1+1;
      buffer := byte(Fil1.FileString[kursor]);
      buf2 := buffer;
      kursor := kursor+1;
      Sch1 := Sch1+1;
      buffer := byte(Fil1.FileString[kursor]);
      buf3 := buffer;
      kursor := kursor+1;
      Sch1 := Sch1+1;
      buffer := byte(Fil1.FileString[kursor]);
      buf4 := buffer;
      DL1 := GetDLBig(buf1,buf2,buf3,buf4);
    end;
    // .
    if DL1+10 = fil1.siz then begin
      //  ,  ...
      numerator1 := Dl1-Sch1;
      //    
      // 1 .
      repeat
        //  ""
        sch1 := 0;
        kursor := kursor+1;
        sch1 := sch1+1;
        numerator1 := numerator1-1;
        buffer := byte(Fil1.FileString[kursor]);
        NumerRazd2 := buffer;
        //   ...
        foldnam2 := FoldNam1+IntToStr(NumerRazd2)+'\';
        MkDir(FoldNam2);
        //  ""
        kursor := kursor+1;
        sch1 := sch1+1;
        numerator1 := numerator1-1;
        buffer := byte(Fil1.FileString[kursor]);
        if chetnoe(buffer) then begin
          //  .
          DL2 := GetDLSmall(buffer);
        end
        else begin
          //  .
          buf1 := buffer;
          kursor := kursor+1;
          Sch1 := Sch1+1;
          numerator1 := numerator1-1;
          buffer := byte(Fil1.FileString[kursor]);
          buf2 := buffer;
          kursor := kursor+1;
          Sch1 := Sch1+1;
          numerator1 := numerator1-1;
          buffer := byte(Fil1.FileString[kursor]);
          buf3 := buffer;
          kursor := kursor+1;
          Sch1 := Sch1+1;
          numerator1 := numerator1-1;
          buffer := byte(Fil1.FileString[kursor]);
          buf4 := buffer;
          DL2 := GetDLBig(buf1,buf2,buf3,buf4);
        end;
        //     2- .
        numerator2 := DL2-Sch1;
        // 2 
        NumerRazd3 := 0;
        repeat
          //  ,   "".
          //     .
          Fil2 := TFileInString.Init;
          Fil2.MakNewFile;
          //  .
          Sch1 := 0;
          kursor := kursor+1;
          numerator1 := numerator1 - 1;
          numerator2 := numerator2 - 1;
          Sch1 := Sch1+1;
          buffer := byte(Fil1.FileString[kursor]);
          //   ...
          Fil2.AddByte(buffer);
          // ...
          //NumerRazd3 := buffer;
          //        1   .
          NumerRazd3 := NumerRazd3+1;
          //   ...
          kursor := kursor+1;
          numerator1 := numerator1 - 1;
          numerator2 := numerator2 - 1;
          Sch1 := Sch1+1;
          buffer := byte(Fil1.FileString[kursor]);
          Fil2.AddByte(buffer);
          if chetnoe(buffer) then begin
            //  .
            DL3 := GetDLSmall(buffer);
          end
          else begin
            //  .
            buf1 := buffer;
            kursor := kursor+1;
            numerator1 := numerator1 - 1;
            numerator2 := numerator2 - 1;
            Sch1 := Sch1+1;
            buffer := byte(Fil1.FileString[kursor]);
            Fil2.AddByte(buffer);
            buf2 := buffer;
            kursor := kursor+1;
            numerator1 := numerator1 - 1;
            numerator2 := numerator2 - 1;
            Sch1 := Sch1+1;
            buffer := byte(Fil1.FileString[kursor]);
            Fil2.AddByte(buffer);
            buf3 := buffer;
            kursor := kursor+1;
            numerator1 := numerator1 - 1;
            numerator2 := numerator2 - 1;
            Sch1 := Sch1+1;
            buffer := byte(Fil1.FileString[kursor]);
            Fil2.AddByte(buffer);
            buf4 := buffer;
            DL3 := GetDLBig(buf1,buf2,buf3,buf4);
          end;
          //     3- ...
          numerator3 := DL3-Sch1;
          // 3-  (   ...)
          repeat
            kursor := kursor+1;
            numerator1 := numerator1 - 1;
            numerator2 := numerator2 - 1;
            numerator3 := numerator3 - 1;
            buffer := byte(Fil1.FileString[kursor]);
            Fil2.AddByte(buffer);
          until numerator3 = 0;
          //   ""  .
          fil2.Save(foldnam2+GenerateNumName(NumerRazd3,'')+'.zap');
          // ...
          fil2.Free;
          ShowProcessF.PrBar.Position := kursor;
          ShowProcessF.PrBar.Refresh;
        until numerator2 = 0;
      until numerator1 = 0;
    end
    else begin
      MessageDLG('  !',mtError,[mbOk],0);
    end;
  end
  else begin
    //,    - 00
    MessageDLG('   '+BasFile+'  00h.      . .',mtError,[mbOk],0);
  end;
  Fil1.Free;
  ShowProcessF.Close;

  Result := 1;
end;

Function GetDlBig (const b1, b2, b3, b4 : byte) : integer;
var
  UnsLong, Sum : integer;
begin
  //     .
  UnsLong := GetUnsignedLongOld(b1,b2,b3,b4);
  Sum := (UnsLong+9) div 2;
  Result := Sum;
end;

Function GetDlSmall(const b1 : byte) : integer;
var
  UnsLong, Sum : integer;
begin
  //     .
  UnsLong := b1;
  Sum := (UnsLong div 2)+2;
  Result := Sum;
end;

Function ZapakBase(const PathIshDir, PathConDir : string) : integer;
var
   //SRec1, SRec2 : TSearchRec;
   DliniRazdelov : array[1..10] of integer;
   DLbasi, numerpapki, numerfila, I, razdelov : integer;
   EstPapka, EstFile : boolean;
   Pathh, FilNam1, FilNam2 : string;
   Fil1, Fil2 : TFileInString;
   buffer : byte;
   buff1 : ChetireBaita;
begin
  //     .
  //,    -.
  //   - 1 -  
  //  -   .
  ShowProcessF.Show;
  ShowProcessF.InfoLab1.caption := PathConDir;
  ShowProcessF.InfoLab2.caption := '    ...';
  ShowProcessF.PrBar.Position := ShowProcessF.PrBar.min;
  ShowProcessF.refresh;
  Fil1 := TFileInString.Init;
  Fil2 := TFileInString.Init;
  For I := 1 to 10 do DliniRazdelov[I] := 0;
  NumerPapki := 0;
  repeat
    EstPapka := false;
    NumerPapki := NumerPapki+1;
    Pathh := PathIshDir+IntToStr(NumerPapki)+'\';
    If DirectoryExists(Pathh) = true then begin
      //  ...
      EstPapka := true;
      // 2 -  .
      NumerFila := 0;
      repeat
        EstFile := false;
        // ...
        NumerFila := NumerFila+1;
        FilNam1 := generateNumName(NumerFila,'')+'.zap';
        FilNam2 := pathh+FilNam1;
        //...
        if FileExistsDiv(FilNam1,pathh) = true then begin
          //  ,   .
          EstFile := true;
          //Fil1 := TFileInString.Init;
          Fil1.Load(FilNam2);
          DliniRazdelov[NumerPapki] := DliniRazdelov[NumerPapki]+Fil1.Siz;
          //Fil1.free;
        end;
      until EstFile = false;
    end;
  until EstPapka = false;
  // - 
  Razdelov := NumerPapki-1;
  //       ....
  //   .
  DLBasi := 0;
  For I := 1 to razdelov do begin
    if DliniRazdelov[I] < 128 then begin
      // 
      DliniRazdelov[I] := DliniRazdelov[I]+2;
    end
    else begin
      // 
      DliniRazdelov[I] := DliniRazdelov[I]+5;
    end;
    DLBasi := DLBasi+DliniRazdelov[I];
  end;
  //  ...
  if DLBasi < 128 then begin
    // 
    DLBasi := DLBasi+2;
  end
  else begin
    // 
    DLBasi := DLBasi+5;
  end;
  //     ...
  //  
  ShowProcessF.InfoLab1.caption := PathConDir;
  ShowProcessF.InfoLab2.caption := '       ...';
  ShowProcessF.PrBar.Position := ShowProcessF.PrBar.min;
  ShowProcessF.refresh;
  fil2.MakNewFile;
  // .
  buffer := 1;
  Fil2.AddByte(buffer);
  //   ...
  if DlBasi < 130 then begin
    buffer := MakeDLSmall(DlBasi);
    Fil2.AddByte(buffer);
  end
  else begin
    buff1 := MakeDlBig(DlBasi);
    Fil2.AddByte(buff1[1]);
    Fil2.AddByte(buff1[2]);
    Fil2.AddByte(buff1[3]);
    Fil2.AddByte(buff1[4]);
  end;
  //  -   .
  For I := 1 to razdelov do begin
    //    I
    buffer := I;
    Fil2.AddByte(buffer);
    //  ...
    if DliniRazdelov[I] < 130 then begin
      buffer := MakeDLSmall(DliniRazdelov[I]);
      Fil2.AddByte(buffer);
    end
    else begin
      buff1 := MakeDlBig(DliniRazdelov[I]);
      Fil2.AddByte(buff1[1]);
      Fil2.AddByte(buff1[2]);
      Fil2.AddByte(buff1[3]);
      Fil2.AddByte(buff1[4]);
    end;
    //       ( ).
    
    // ,    0...
    Pathh := PathIshDir+inttostr(I)+'\';
    NumerFila := 0;
    repeat
      //  ....
      EstFile := false;
      NumerFila := NumerFila+1;
      FilNam1 := generateNumName(NumerFila,'')+'.zap';
      FilNam2 := pathh+FilNam1;
      if fileexistsDiv(FilNam1,pathh) then begin
        // 
        EstFile := true;
        // .
        fil1.Load(FilNam2);
        Fil2.FileString := Fil2.FileString+Fil1.FileString;
        //Fil2.Siz := Fil2.Siz + Fil1.Siz;
      end;
    until EstFile = false;
  end;
  //   .  "".
  Fil2.AddByte(0);
  Fil2.AddByte(0);
  Fil2.AddByte(2);
  Fil2.AddByte(12);
  Fil2.AddByte(2);
  Fil2.AddByte(8);
  Fil2.AddByte(1);
  Fil2.AddByte(0);
  Fil2.AddByte(0);
  Fil2.AddByte(0);
  // .    - .
  Fil2.Save(PathConDir);
  // ...
  //ShowMessage('');    // 
  Fil1.Free;
  Fil2.free;
  ShowProcessF.Close;

  Result := 1;
end;

Function MakeDlBig(const int : integer) : ChetireBaita;
begin
  //      .
  Result := UngetUnsignedLong(((int*2)-9));
end;

Function MakeDlSmall(const int : integer) : byte;
begin
  //       .
  result := ((int-2)*2);
end;

Constructor TZapisBaziPz.Init;
begin
  // (   ) -       .
  FieldsCreated := false;
  ZapisCreated := false;
  FieldOv := 0;
  Siz := 0;
  SizFieldOv := 0;
  FieldsString := '';
  ZapisString := '';
end;

Procedure TZapisBaziPz.LoadZap(const ZapSt : ANSIString; sz : integer);
var
  kursor, DLFilda : integer;
  b1, b2, b3, b4 : byte;
begin
  //   ,      .
  // . .
  ZapisString := '';
  FieldsString := '';
  ZapisString := ZapSt;
  Siz := sz;
  FieldOv := 0;
  SizFieldOv := 0;
  kursor := 2;
  //SizFieldOv := 2;
  //  = 1 -   1-  .
  DLFilda := 1;
  //  ,    ( +).
  //    (  )   
  //  .
  if Chetnoe(byte(ZapisString[kursor])) = true then begin
    //   ,    .  
    //(    :)  )
  end
  else begin
    //  .  
    kursor := kursor+3;
    //SizFieldOv := SizFieldOv+3; //    !
  end;

  //   ""  
  b1 := 0;
  b2 := 0;
  b3 := 0;

  // ...
  repeat
    // ,      .
    kursor := kursor+1;
    FieldsString := FieldsString+ZapisString[kursor];
    SizFieldOv := SizFieldOv+1;
    DLFilda := DLFilda-1;
    //     -   .
    if DLFilda = -1 then begin
      //   
      FieldOv := FieldOv+1;
    end;
    if DLFilda = -2 then begin
      //   -    .
      //   .
      if Chetnoe(byte(ZapisString[kursor-1])) = true then begin
        // .    (  2  ).
        DLFilda := GetDLSmall(byte(ZapisString[kursor-1]))-2;
      end
      else begin
        // .      1 .
        b1 := byte(ZapisString[kursor-1]);
      end;
    end;
    if DLFilda = -3 then begin
      // .      1 .
      b2 := byte(ZapisString[kursor-1]);
    end;
    if DLFilda = -4 then begin
      // .      1 .
      b3 := byte(ZapisString[kursor-1]);
    end;
    if DLFilda = -5 then begin
      // .  1 ,      .
      b4 := byte(ZapisString[kursor-1]);
      DLFilda := GetDLBig(b1, b2, b3, b4)-5 // 5   .
    end;
  until kursor = Siz;
  //FieldOv := FieldOv-1;
  FieldsCreated := true;
  ZapisCreated := true;
end;

Procedure TZapisBaziPz.BuildZap;
var
  ChBaita : ChetireBaita;

begin
  //     .
  //      1.
  ZapisString := '';
  siz := 0;
  ZapisString := ZapisString+char(byte(01));
  siz := 1;
  // . +2 - .     .
  if SizFieldOv+2 < 130 then begin
    // .
    ZapisString := ZapisString+char(MakeDLSmall(SizFieldOv+2));
    siz := siz+1;
  end
  else begin
    // .
    ChBaita := MakeDLBig(SizFieldOv+5);
    // ...
    ZapisString := ZapisString+char(ChBaita[1]);
    ZapisString := ZapisString+char(ChBaita[2]);
    ZapisString := ZapisString+char(ChBaita[3]);
    ZapisString := ZapisString+char(ChBaita[4]);
    siz := siz+4;
  end;
  //  .
  ZapisString := ZapisString+FieldsString;
  siz := siz+SizFieldOv;
  ZapisCreated := true;
end;

Function TZapisBaziPz.GetField(const FieldNum : integer) : ANSIString;
var
  I, J, kursor, DLFilda : integer;
  b1, b2, b3, b4 : byte;
  StrokaPolya : string;
begin
  //       .
  //   .
  If (FieldNum > 0) and (FieldNum <= FieldOv) then begin
    //     .
    kursor := 1;
    For I := 1 to FieldNum do begin
      // ""  .
      kursor := kursor+1; //    
      if chetnoe(byte(FieldsString[kursor])) = true then begin
        // , ...
        DLFilda := GetDLSmall(byte(FieldsString[kursor]))-2;
      end
      else begin
        // .        .
        b1 := byte(FieldsString[kursor]);
        kursor := kursor+1;
        b2 := byte(FieldsString[kursor]);
        kursor := kursor+1;
        b3 := byte(FieldsString[kursor]);
        kursor := kursor+1;
        b4 := byte(FieldsString[kursor]);
        DLFilda := GetDLBig(b1,b2,b3,b4)-5;
      end;
      kursor := kursor+1; //-    .
      //       . 
      //    .  -  .
      if I <> FieldNum then kursor := kursor+DLFilda
      else begin
        // .
        StrokaPolya := '';
        For J := 0 to DLFilda-1 do begin
          StrokaPolya := StrokaPolya+char(FieldsString[kursor+J]);
        end;
        //   
        SizFieldOtv := DLFilda;
      end;
    end;
    // 
    Result := StrokaPolya;
  end
  else begin
    //   ...
    MessageDLG('   !',mtError,[mbOk],0);
    Result := 'ERROR!';
  end;
end;

Procedure TZapisBaziPz.ReWriteField(const FieldNum, sizSt : integer; St: ANSIString);
var
  I, J, kursor, DLFilda : integer;
  b1, b2, b3, b4 : byte;
  OldStroka : string;
  ChB : ChetireBaita;
begin
  //       ,    .
  //          .
  OldStroka := FieldsString;
  FieldsString := '';
  SizFieldOv := 0;
  kursor := 0;
  For I := 1 to FieldOv do begin
    kursor := kursor+1;
    FieldsString := FieldsString+OldStroka[kursor];
    SizFieldOv := SizFieldOv+1;
    kursor := kursor+1;
    if I <> FieldNum then begin
      // 
      FieldsString := FieldsString+OldStroka[kursor];
      SizFieldOv := SizFieldOv+1;
      //     .
      if chetnoe(byte(OldStroka[kursor])) then begin
        DLFilda := GetDLSmall(byte(OldStroka[kursor]))-2;
      end
      else begin
        b1 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        FieldsString := FieldsString+OldStroka[kursor];
        SizFieldOv := SizFieldOv+1;
        b2 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        FieldsString := FieldsString+OldStroka[kursor];
        SizFieldOv := SizFieldOv+1;
        b3 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        FieldsString := FieldsString+OldStroka[kursor];
        SizFieldOv := SizFieldOv+1;
        b4 := byte(OldStroka[kursor]);
        DLFilda := GetDlBig(b1,b2,b3,b4)-5;
      end;
      //  ...
      for J := 1 to DLFilda do begin
        kursor := kursor+1;
        FieldsString := FieldsString+OldStroka[kursor];
        SizFieldOv := SizFieldOv+1;
      end;
    end
    else begin
      // .
      //        
      //     .
      if chetnoe(byte(OldStroka[kursor])) then begin
        DLFilda := GetDLSmall(byte(OldStroka[kursor]))-2;
      end
      else begin
        b1 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        b2 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        b3 := byte(OldStroka[kursor]);
        kursor := kursor+1;
        b4 := byte(OldStroka[kursor]);
        DLFilda := GetDlBig(b1,b2,b3,b4)-5;
      end;
      //   ...
      for J := 1 to DLFilda do begin
        kursor := kursor+1;
      end;
      //     .
      // 
      if sizST+2 < 130 then begin
        b1 := MakeDLSmall(sizST+2);
        FieldsString := FieldsString+char(b1);
        SizFieldOv := SizFieldOv+1;
      end
      else begin
        ChB := MakeDLBig(sizST+5);
        FieldsString := FieldsString+char(ChB[1]);
        SizFieldOv := SizFieldOv+1;
        FieldsString := FieldsString+char(ChB[2]);
        SizFieldOv := SizFieldOv+1;
        FieldsString := FieldsString+char(ChB[3]);
        SizFieldOv := SizFieldOv+1;
        FieldsString := FieldsString+char(ChB[4]);
        SizFieldOv := SizFieldOv+1;
      end;
      // 
      For J := 1 to sizST do begin
        FieldsString := FieldsString+st[J];
        SizFieldOv := SizFieldOv+1;
      end;
    end;
  end;
end;

Procedure TZapisBaziPz.CreateFields(const FieldNum : integer; NomPoley : StoIntegerov);
var
  I : integer;
begin
  //   (    ).
  FieldsCreated := true;
  ZapisCreated := false;
  FieldOv := 0;
  Siz := 0;
  SizFieldOv := 0;
  FieldsString := '';
  ZapisString := '';
  for I := 1 to FieldNum do begin
    FieldsString := FieldsString+char(byte(NomPoley[I]));
    SizFieldOv := SizFieldOv+1;
    FieldsString := FieldsString+char(byte(0));
    SizFieldOv := SizFieldOv+1;
  end;
  FieldOv := FieldNum;
end;

Procedure VipravitFaili(DirPath : string);
var
  I : integer;
  FailEst : boolean;
  FNam, FNam2 : string;
begin
  //      ( 2    ).
  // -    .
  I := 0;
  repeat
    I := I+1;
    FailEst := false;
    FNam := GenerateNumName(I,'')+'.zap';
    If FileExistsDiv(FNam,DirPath) = true then FailEst := true;
  until FailEst = false;
  //...
  repeat
    I := I+1;
    FailEst := false;
    FNam := GenerateNumName(I-1,'')+'.zap';
    FNam2 := GenerateNumName(I,'')+'.zap';
    if FileExistsDiv(FNam2,DirPath) = true then begin
      FailEst := true;
      RenameFile(DirPath+FNam2,DirPath+FNam);
    end;
  until FailEst = false;
end;

Function OtkusitPodPole(Point1 : PointToStr) : string;
var
  Otkusheno, DL : Integer;
begin
  //       .
  //   MySys.pas

  //  .
  if Chetnoe(byte(Point1^[2])) = true then begin
    // .
    DL := GetDlSmall(byte(Point1^[2]))-2;
    Otkusheno := 2;
  end
  else begin
    // 
    DL := GetDlBig(byte(Point1^[2]),byte(Point1^[3]),byte(Point1^[4]),byte(Point1^[5]))-5;
    Otkusheno := 5;
  end;

  //     !!!!!
  OtkusitStrokeBashku(@Point1^,Otkusheno);
  //    ...
  Result := OtkusitStrokeBashku(@Point1^,DL);

  //   ...
end;

Function AddPodPole(const Str, AddStr : string; zagol : integer): string;
var
  SizText : integer;
  ChBaita : ChetireBaita;
begin
  //       .

  //  .

  Result := Str;
  Result := Result+char(byte(zagol));

  //  ( ) .
  SizText := Length(AddStr);
  if SizText+2 < 130 then begin
    // .
    Result := Result+char(MakeDLSmall(SizText+2));
  end
  else begin
    // .
    ChBaita := MakeDLBig(SizText+5);
    // ...
    Result := Result+char(ChBaita[1]);
    Result := Result+char(ChBaita[2]);
    Result := Result+char(ChBaita[3]);
    Result := Result+char(ChBaita[4]);
  end;

  //   ...
  Result := Result+AddStr;

  //   .
end;

Function UnsLongToShopInfo(const Int : integer) : string;
var
  Magazins : array[1..30] of boolean;
  I, int1 : integer;

begin
  //       -  
  //  (  ).

  // 
  For I := 1 to 30 do begin
    Magazins[I] := false;
  end;

  //        .
  int1 := int;
  For I := 31 downto 1 do begin
    If int1 < GetMagazChislo(I) then begin
      //,    ...
      If Int1 >= GetMagazChislo(I-1) then begin
        // .
        Magazins[I-1] := true;
        // .
        Int1 := Int1-GetMagazChislo(I-1);
      end;
    end;
  end;

  //    .
  result := '';
  For I := 1 to 30 do begin
    If Magazins[I] = true then begin
      // 

      //      
      //  .
      if result <> '' then result := result+',';

      //  
      result := result+IntToStr(I);
    end;
  end;

  //     
  //   = ''   ...

  If Int = 0 then result := '0';
end;

Function GetMagazChislo(const num : integer) : integer;
var
  I : integer;

begin
  //    " ",  
  //   .
  If (Num < 32) and (Num > 0) then begin
    //  30 
    result := 1;
    If Num <> 1 then begin
      //     .
      For I := 1 to num-1 do begin
        result := result*2;
      end;
    end;
  end
  else begin
    //   .
    result := 0;
  end;
end;

Function CheckShopInfo (const Str : string) : boolean;
var
  I : integer;
  ind1, NowCif : boolean;

begin
  //      .
  result := true;

  //     .
  If (Str <> '') then begin
    If IsCifra(Str[1]) = false then result := false;

    //   -   .
    If result = true then begin
      I := 1;
      NowCif := true;
      repeat
        ind1 := true;
        I := I+1;
        If (Str[I] <> #0) and (Str[I] <> ' ') then begin
          If IsCifra(Str[I]) = false then begin
            If Str[I] <> ',' then result := false
            else If NowCif = false then result := false;
            NowCif := false;
          end
          else begin
            NowCif := true;
          end;
        end
        else begin
          //  
          ind1 := false;
          If NowCif = false then result := false;
        end;
      until ind1 = false;
    end;

  end
  else result := false;
end;

Function ShopInfoToUnsLong(const Str : string) : integer;
var
  Magazins : array[1..30] of boolean;
  I : integer;
  Buf : string;

begin
  //   ,  
  //! !    
  // (4 ) -    .

  // 
  For I := 1 to 30 do begin
    Magazins[I] := false;
  end;

  //     .
  I := 0;
  Buf := '';
  repeat
    I := I+1;
    If (Str[I] <> #0) and (Str[I] <> ' ') and (Str[I] <> ',') then begin
      //  .
      Buf := Buf + Str[I];
    end
    else begin
      //  .

      //   .
      If (StrToInt(Buf) < 31) and (StrToInt(Buf) > 0) then begin
        Magazins[StrToInt(Buf)] := true;
      end;

      // 
      Buf := '';
    end;
  until (Str[I] = #0) or (Str[I] = ' ');

  //  .

  result := 0;
  For I := 1 to 30 do begin
    If Magazins[I] = true then begin
      // .
      result := result+GetMagazChislo(I);
    end;
  end;
end;

Function GetUnkStr(const Unk : string; UnkSiz : integer) : string;
var
  UnkEmpty : boolean;
  I : integer;
begin
  //,   -  ...
  UnkEmpty := true;
  For I := 1 to UnkSiz do begin
    //   ...
    If Unk[I] <> #0 then UnkEmpty := false;
  end;
  If UnkEmpty then begin
    // 
    Result := '  (  ).';
  end
  else begin
    //  
    Result := '   (   ).';
  end;
  Result := Result+'   '+IntToStr(UnkSiz)+' .';
end;

Function ListToStr(const ListStr : string) : string;
var
  OtkusStr, AddStr : string;
begin
  //     list 
  //,  .
  Result := '';
  If ListStr <> '' then begin
    OtkusStr := ListStr;
     //    ...
    repeat
      AddStr := PzDbStrToStr(OtkusitPodPole(@OtkusStr));
      If Result <> '' then Result := Result+',';
      Result := Result+AddStr;
    until OtkusStr = '';
  end;  
end;

Function CheckList (const Str : string) : boolean;
var
  I : integer;
  WasZapiataia : boolean;

begin
  //     .
  result := true;
  If Str <> '' then begin
    //  -  .
    If Str[1] <> ',' then begin
      //   -  .
      //       ,
      If Str[Length(Str)] <> ',' then begin
        //   -  .
        //    2-  .
        WasZapiataia := false;
        For I := 1 to Length(Str) do begin
          //    2-  
          If Str[I] = ',' then begin
            //  ...
            If WasZapiataia = false then begin
              WasZapiataia := true;
            end
            else begin
              // 2  .
              result := false;
            end;
          end
          else begin
            // .
            WasZapiataia := false;
          end;
        end;
      end
      else begin
        //   - .
        result := false;
      end;
    end
    else begin
      //   - .
      result := false;
    end;
  end;  
end;

Function ListBezProbelov(const Str : string) : string;
var
  ReadStr : string;
  WasZapiataia : boolean;
  I, Dlinna : integer;
begin
  //       (!) 
  // -   .
  Dlinna := Length(Str); //     NewStr 
  WasZapiataia := false;
  ReadStr := '';
  For I := 1 to Dlinna do begin
    If Str[I] = ',' then begin
      //  
      WasZapiataia := true;
      ReadStr := ReadStr+Str[I];
    end
    else begin
      //   .
      //     .
      If WasZapiataia = true then begin
        // .
        //   -  .
        //  -      .
        //   -     .
        //      
        //-   .
        If Str[I] <> ' ' then begin
          ReadStr := ReadStr + Str[I];
          WasZapiataia := false;
        end;
      end
      else begin
        //  .
        //   .
        ReadStr := ReadStr+Str[I];
      end;
    end;
  end;
  Result := ReadStr;
end;

Function StrToList(const Str : string) : string;
var
  I : integer;
  GotStr : string;
begin
  // -   
  //    .

  Result := '';
  If Str <> '' then begin
    I := 0;
    repeat
      // 1 ..
      GotStr := '';
      repeat
        I := I+1;
        If (Str[I] <> ',') and (Str[I] <> #0) then begin
          GotStr := GotStr+Str[I];
        end;
      until (Str[I] = ',') or (Str[I] = #0);
      //   .
      Result := AddPodPole(Result,StrToPzDbStr(GotStr).Str,1);
    until Str[I] = #0;
  end;
end;

Function SelectValue(const List : string) : string;
begin
  ValueSelectorF.ValueSelectorF_List := List;
  ValueSelectorF.ValueSelectorF_Idx := 0;
  ValueSelectorF.ShowModal;
  If ValueSelectorF.ModalResult = mrOk then begin
    Result := ValueSelectorF.ValueSelectorF_Return;
  end
  else begin
    Result := #13;
  end;
end;

Function SelectValueEx(const List : string; Idx : integer) : string;
begin
  ValueSelectorF.ValueSelectorF_List := List;
  ValueSelectorF.ValueSelectorF_Idx := Idx;
  ValueSelectorF.ShowModal;
  If ValueSelectorF.ModalResult = mrOk then begin
    Result := ValueSelectorF.ValueSelectorF_Return;
  end
  else begin
    Result := #13;
  end;
end;

Function _4bTEXTListToStr(const ListStr : string) : string;
var
  OtkusStr, AddStr : string;
begin
  //     list 
  //,  .
  Result := '';
  If ListStr <> '' then begin
    OtkusStr := ListStr;
     //    ...
    repeat
      AddStr := PzDbStrToStr(OtkusitPodPole(@OtkusStr));
      If Result <> '' then Result := Result+',';
      Result := Result+AddStr;
    until OtkusStr = '';
  end;  
end;

Function ListTo4bTEXTStr(const Str : string) : string;
var
  I : integer;
  GotStr : string;
begin
  //     ,  ,
  //    
  //  4bTEXT.
  // -   
  //    .

  Result := '';
  If Str <> '' then begin
    I := 0;
    repeat
      // 1 ..
      GotStr := '';
      repeat
        I := I+1;
        If (Str[I] <> ',') and (Str[I] <> #0) then begin
          GotStr := GotStr+Str[I];
        end;
      until (Str[I] = ',') or (Str[I] = #0);
      //   .
      Result := AddPodPole(Result,StrTo4bTEXT(GotStr),1);
    until Str[I] = #0;
  end;
end;

Function CheckList4bTEXT(const Str : string) : boolean;
var
  I, J : integer;
  
begin
  //   ,        4  -  
  //  4bTEXTList.
  //       .

  //  -     .

  Result := CheckList(Str);

  If Result = true then begin
    //    ,     ......
    J := 0;
    For I := 1 to length(Str) do begin
      If Str[I] <> ',' then begin
        //   
        J := J+1;
      end
      else begin
        // ,  ...
        If J > 4 then begin
          //   ...
          Result := false;
        end;

        // ...
        J := 0;
      end;
    end;

    //   (     )
    If J > 4 then begin
      //   ...
      Result := false;
    end;

  end;
end;

Function EditASound(const Str : string) : string;

begin
  //       ASound.
  ASoundEditorF.InputStr := Str;
  ASoundEditorF.ShowModal;
  Result := ASoundEditorF.OutputStr;
end;

Function GetASoundStr(const Str : string) : string;
var
  I : integer;
  TempStr : string;
begin
  //,   -  ASound...
  If Length(Str) <> 0 then begin
    //    
    TempStr := Str;
    //...
    I := 0;
    repeat
      I := I+1;
      OtkusitPodPole(@TempStr);
    until Length(TempStr) = 0;

    //  ...
    Result := '   '+IntToStr(I)+'  ().';
  end
  else begin
    // .
    Result := '.  ()   .';
  end;
  
end;

Function AddDirToRes(const ResFile, DirPath : string) : string;
var
  si: TStartupInfo;
  pi: TProcessInformation;
  ResFileShort, DirPathShort, TempName : string;
  AllOk, TNFinded : boolean;
  I : integer;
begin
  //     - .
  AllOk := true;
  TNFinded := false;  //    ,   ...
  Result := '';  //    -   .

  //  ...
  If FileExists(ResFile) = true then begin
    //   -   ,
    //   ...
    ResFileShort := FileShortPath(ResFile);
  end
  else begin
    //   ...
    If DirectoryExists(ExtractFilePath(ResFile)) = true then begin
      //      .
      //    .
      //    ""  -       .
      //   -   
      //   -    .

      //  .
      I := 0;

      repeat
        I := I+1;
        TempName := ExtractFilePath(ResFile)+'tr'+IntToStr(I)+'.res';
        If FileExists(TempName) = true then begin
          //    
          //  
        end
        else begin
          //   ,     .
          TNFinded := true;

          //         (  )
          // ...
          ResFileShort := FileShortPath(ExtractFilePath(TempName))+ExtractFileName(TempName);
        end;
      until (TNFinded = true) or (I = 2147483647);

      If TNFinded = false then begin
        //      ,     .
        AllOk := false;
        Result := '     :(.   .';
      end;
    end
    else begin
      //      ,    ...
      //  ....
      AllOk := false;
      Result := ' ,      :(.   .';
    end;
  end;

  If DirectoryExists(DirPath) = true then begin
    DirPathShort := FileShortPath(DirPath);
  end
  else begin
    //  .  ...
    AllOk := false;
    Result := ' ,        :(.   .';
  end;  

  //,     (  -    ).

  If AllOk = true then begin
    //   ...
    
    //  ...
    ZeroMemory( @si, SizeOf( TStartupInfo ) );
    si.cb := SizeOf( TStartupInfo );
    si.dwFlags := STARTF_USESHOWWINDOW;
    si.wShowWindow := SW_SHOWNORMAL;
    //   ...
    //ShowMessage(path+'resbuild.exe'+' '+' a '+ResFileShort+' *'+'  |  '+DirPathShort);
    CreateProcess( PChar(path+'resbuild.exe'),
                   PChar(' a '+ResFileShort+' *'),
                   nil,
                   nil,
                   False,
                   CREATE_NEW_CONSOLE,
                   nil,
                   PChar(DirPathShort),
                   si,
                   pi);
    //  ...
    repeat
      Application.ProcessMessages;
    until WaitForSingleObject(pi.hProcess,0)<>Wait_Timeout;
    //ShowMessage(' ');
    CloseHandle( pi.hThread );
    CloseHandle( pi.hProcess );

    // -    ...
    If TNFinded = true then begin
      //    
      If FileExists(ResFile) = true then begin
        //    ...
        DeleteFile(ResFile);
      end;

      //  -      ...
      RenameFile(TempName,ResFile);
    end;
  end;  
end;

Function UnPackResToDir(const ResFile, DirPath : string) : string;
var
  si: TStartupInfo;
  pi: TProcessInformation;
  ResFileShort, DirPathShort : string;
  AllOk : boolean;
begin
  //     - .
  AllOk := true;
  Result := '';  //    -   .

  //  ...
  If FileExists(ResFile) = true then begin
    ResFileShort := FileShortPath(ResFile);
  end
  else begin
    //    ...
    AllOk := false;
    Result := ',      :(.   .';
  end;

  If DirectoryExists(DirPath) = true then begin
    DirPathShort := FileShortPath(DirPath);
  end
  else begin
    //    ...
    ForceDirectories(DirPath);  // ...
    If DirectoryExists(DirPath) = true then begin
      DirPathShort := FileShortPath(DirPath);
    end
    else begin
      //   ...
      AllOk := false;
      Result := '  ,      :(.   .';
    end;
  end;  

  If AllOk = true then begin
    //  ...
    ZeroMemory( @si, SizeOf( TStartupInfo ) );
    si.cb := SizeOf( TStartupInfo );
    si.dwFlags := STARTF_USESHOWWINDOW;
    si.wShowWindow := SW_SHOWNORMAL;
    //   ...
    CreateProcess( PChar(path+'resbuild.exe'),
                   PChar(' e '+ResFileShort+' *'),
                   nil,
                   nil,
                   False,
                   CREATE_NEW_CONSOLE,
                   nil,
                   PChar(DirPathShort),
                   si,
                   pi );
    //  ...
    repeat
      Application.ProcessMessages;
    until WaitForSingleObject(pi.hProcess,0)<>Wait_Timeout;
    //ShowMessage(' ');
    CloseHandle( pi.hThread );
    CloseHandle( pi.hProcess );
  end;  
end;

Function OptimizeRes(const ResFile : string) : string;
var
  si: TStartupInfo;
  pi: TProcessInformation;
  ResFileShort, DirPathShort : string;
  AllOk : boolean;
begin
  //    ...
  AllOk := true;
  Result := '';  //    -   .

  //  ...
  If FileExists(ResFile) = true then begin
    ResFileShort := FileShortPath(ResFile);
  end
  else begin
    //   ...
    AllOk := false;
    Result := ',      :(.   .';
  end;

  If AllOk = true then begin
    //  ...
    ZeroMemory( @si, SizeOf( TStartupInfo ) );
    si.cb := SizeOf( TStartupInfo );
    si.dwFlags := STARTF_USESHOWWINDOW;
    si.wShowWindow := SW_SHOWNORMAL;
    //   ...
    CreateProcess( PChar(path+'resbuild.exe'),
                   PChar(' o '+ResFileShort+' *'),
                   nil,
                   nil,
                   False,
                   CREATE_NEW_CONSOLE,
                   nil,
                   nil,
                   si,
                   pi );
    //  ...
    repeat
      Application.ProcessMessages;
    until WaitForSingleObject(pi.hProcess,0)<>Wait_Timeout;
    //ShowMessage(' ');
    CloseHandle( pi.hThread );
    CloseHandle( pi.hProcess );
  end;  
end;

Function ModalAddDirToRes(const ResFile, DirPath : string) : string;
begin
  //   ,    .

  // ...
  ResbuildF.ResFile := ResFile;
  ResbuildF.DirPath := DirPath;
  ResbuildF.ToDoCode := ResbuildForm.RBF_PACK_CODE;
  ResbuildF.ShErrMess := true;

  //"" ...
  ResbuildF.ShowModal;

  // ...
  Result := ResbuildF.ResultStr;
end;

Function ModalUnPackResToDir(const ResFile, DirPath : string) : string;
begin
  //   ,    .

  // ...
  ResbuildF.ResFile := ResFile;
  ResbuildF.DirPath := DirPath;
  ResbuildF.ToDoCode := ResbuildForm.RBF_UNPACK_CODE;
  ResbuildF.ShErrMess := true;

  //"" ...
  ResbuildF.ShowModal;

  // ...
  Result := ResbuildF.ResultStr;
end;

Function ModalOptimizeRes(const ResFile : string) : string;
begin
  //   ,    .

  // ...
  ResbuildF.ResFile := ResFile;
  ResbuildF.ToDoCode := ResbuildForm.RBF_OPTIMIZE_CODE;
  ResbuildF.ShErrMess := true;

  //"" ...
  ResbuildF.ShowModal;

  // ...
  Result := ResbuildF.ResultStr;
end;

Function GetExtensDirName(const FileName : string) : string;
var
  I : integer;
  Done : boolean;
begin
  //,         
  // -    ,      .
  //   -    "noext"

  Result := FileName;
  Done := false;
  I := Length(Result);
  repeat
    If Result[I] = '.' then begin
      Result[I] := '_';
      Done := true;
    end;
    I := I-1;
  until (I = 0) or (Done = true);

  //   
  If Done = false then begin
    Result := Result+'_noext';
  end;

  //    
  Result := AddLastSlash(Result);
end;

Function GetExtensFileName(const DirName : string) : string;
var
  I, Siz : integer;
  Done : boolean;
  TempStr : string;
  
begin
  //        
  // -         ,
  // .
  //     -    :).

  Result := DelLastSlash(DirName);   //  .
  Siz := Length(Result);

  If Siz > 0 then begin
    //  -     ""
    Done := false;
    If Siz > 6 then begin
      TempStr := CopyEnd(Result,Siz-5);
      If TempStr = '_noext' then begin
        Done := true;
        // ...
        DeleteTail(Result,6);
      end;
    end;

    If Done = false then begin
      //     -   
      // ...
      I := Siz;
      repeat
        If Result[I] = '_' then begin
          Result[I] := '.';
          Done := true;
        end;
        I := I-1;
      until (I = 0) or (Done = true);
    end;

    //    ...
    //   *.res
    If Done = false then begin
      Result := Result+'.res';
    end;
  end
  else begin
    result := '';
  end;
end;

Function SimvCountInStr(const Str : string; Simv : Char) : integer;
var
  StrSiz, I : integer;
begin
  //       Simv   .
  StrSiz := Length(Str);  // ...
  Result := 0;            // ...

  If StrSiz > 0 then begin
    //    ...
    For I := 1 to StrSiz do begin
      //   -   .
      If Str[I] = Simv then begin
        Result := Result+1;
      end;
    end;
  end;
end;

Function UnPackResDialog(const FileName : string) : string;
begin
  //     .
  RBUnPackOptF := TRbUnPackOptF.Create(Application);
  RBUnPackOptF.UnPackFileName := FileName;
  RBUnPackOptF.ShowModal;
  If RBUnPackOptF.ModalResult = mrOk then begin
    Result := RBUnPackOptF.DirNameEd.Text;
  end
  else begin
    Result := '';   //   .
  end;
  RBUnPackOptF.Free;      //    ...
end;

Function PackResDialog(const DirName : string) : string;
begin
  //     
  RbPackOptF := TRbPackOptF.Create(Application);
  RbPackOptF.PackDirName := DirName;
  RbPackOptF.ShowModal;
  If RbPackOptF.ModalResult = mrOk then begin
    Result := RbPackOptF.FileNameEd.Text;
  end
  else begin
    Result := '';   //   .
  end;  
  RbPackOptF.Free;   //    ...
end;

Function SortStringFileArray(const TheArray : MaskFileArr) : MaskFileArr;
var
  ArrLength, I, J : integer;
  Inserted : bool;

  procedure InsertItem(const ItemNum : integer; const Text1 : string; const Text2 : string);
  var
    I : integer;
    
  begin
    //  ,       .

    if ItemNum > ArrLength then begin
      //    .
      Result[ItemNum,1] := Text1;
      Result[ItemNum,2] := Text2;
      ArrLength := ItemNum
    end
    else begin
      //    .
      //       .

      for I := ArrLength downto ItemNum do begin
        //   .
        Result[I+1] := Result[I];
      end;

      //     .
      Result[ItemNum,1] := Text1;
      Result[ItemNum,2] := Text2;
      //    .
      ArrLength := ArrLength+1;
    end;

  end;

begin
  //      -  .
  ArrLength := 0;

  //  
  i := 0;
  repeat
    i := i+1;

    if Result[i,1] <> '' then begin
      Result[i,1] := '';
      Result[i,2] := '';
    end;

  until Result[i+1,1] = '';


  // .
  i := 0;
  repeat
    i := i+1;
    Inserted := false;

    // -   ,  
    //     ,   -  .
    j := 0;
    repeat
      j := j+1;
      if AnsiCompareText(TheArray[i,2],Result[j,2]) < 0 then begin
        //  .
        InsertItem(j,TheArray[i,1],TheArray[i,2]);
        Inserted := true;
      end;
    until (Result[j+1,1] = '') or (Inserted = true);

    //   -    .
    if Inserted = false then begin
      InsertItem(ArrLength+1,TheArray[i,1],TheArray[i,2]);
    end;  

  until TheArray[i+1,1] = '';

end;

end.


