///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit RbPackOptForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, initer, KOL, KOLForPaths;

type
  TRbPackOptF = class(TForm)
    DirNameEd: TEdit;
    FileNameEd: TEdit;
    OptimizeCB: TCheckBox;
    OkBut: TButton;
    CancelBut: TButton;
    Label1: TLabel;
    Label2: TLabel;
    BrowseDirBut: TButton;
    BrowseFileBut: TButton;
    GnrNamBut: TButton;
    ReWriteCB: TCheckBox;
    SFD1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure BrowseDirButClick(Sender: TObject);
    procedure GnrNamButClick(Sender: TObject);
    procedure BrowseFileButClick(Sender: TObject);
    procedure OkButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    PackDirName : string;
  end;

var
  RbPackOptF: TRbPackOptF;

implementation

{$R *.dfm}

procedure TRbPackOptF.FormShow(Sender: TObject);
begin
  //  ...
  DirNameEd.Text := PackDirName;
  FileNameEd.Text := GetExtensFileName(PackDirName);
end;

procedure TRbPackOptF.CancelButClick(Sender: TObject);
begin
  ModalResult := mrCancel;   //   ??     :)
end;

procedure TRbPackOptF.BrowseDirButClick(Sender: TObject);
var
  ODD1 : POpenDirDialog;
begin
  //   -    ...

  // ...
  ODD1 := NewOpenDirDialog(' ,     ',[]);
  If DirectoryExists(DirNameEd.Text) = true then begin
    ODD1.InitialPath := DirNameEd.Text;
  end
  else begin
    ODD1.InitialPath := DefalDir;
  end;
  ODD1.WndOwner := Application.Handle;  // " "...

  //        -  .
  If ODD1.Execute = true then begin
    DefalDir := AddLastSlash(ODD1.Path);
    AnIniFil.Load(IniFilPath);  // .
    AnIniFil.WriteString('MainSettings','DefalDir',DefalDir);
    AnIniFil.Save(IniFilPath);  // .    :)
    DirNameEd.Text := DefalDir;

    // ""  ...
    FileNameEd.Text := GetExtensFileName(DirNameEd.Text);
  end;

  //  ...
  ODD1.Free;
end;

procedure TRbPackOptF.GnrNamButClick(Sender: TObject);
begin
  FileNameEd.Text := GetExtensFileName(DirNameEd.Text);
end;

procedure TRbPackOptF.BrowseFileButClick(Sender: TObject);
begin
  //   -    ...

  // ...
  If DirectoryExists(ExtractFilePath(FileNameEd.Text)) = true then begin
    SFD1.InitialDir := ExtractFilePath(FileNameEd.Text);
    SFD1.FileName := ExtractFileName(FileNameEd.Text);
  end
  else begin
    SFD1.InitialDir := DefalDir;
  end;

  //        -  .
  If SFD1.Execute = true then begin
    FileNameEd.Text := SFD1.FileName;
  end;
end;

procedure TRbPackOptF.OkButClick(Sender: TObject);
begin
  //       ...

  If FileExists(FileNameEd.Text) = true then begin
    //    -      ...
    SetFileAttributes(PChar(FileNameEd.Text),FILE_ATTRIBUTE_ARCHIVE);
    If ReWriteCB.Checked = true then begin
      //   -  .
      DeleteFile(FileNameEd.Text);
    end;  
  end;

  //   -   :).
  ModalAddDirToRes(FileNameEd.Text,DirNameEd.Text);

  //   - ...
  If OptimizeCB.Checked = true then begin
    ModalOptimizeRes(FileNameEd.Text);
  end;  

  ModalResult := mrOk;  // ,   :).
end;

end.
