///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglItemsIdbR3Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglItemsIdbR3F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglItemsIdbR3F: TSinglItemsIdbR3F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2, Unknown3, Unknown4, Unknown5 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz, Unk3Siz, Unk4Siz, Unk5Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglItemsIdbR3F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglItemsIdbR3FClosed := true;
  MainForm.ItemsMenu3.Checked := false;
  Action := CaFree;
end;



procedure TSinglItemsIdbR3F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglItemsIdbR3FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';
  ValuesEd.Cells[1,25] := '';
  ValuesEd.Cells[1,26] := '';
  ValuesEd.Cells[1,27] := '';
  ValuesEd.Cells[1,28] := '';
  ValuesEd.Cells[1,29] := '';
  ValuesEd.Cells[1,30] := '';
  ValuesEd.Cells[1,31] := '';
  ValuesEd.Cells[1,32] := '';
  ValuesEd.Cells[1,33] := '';
  ValuesEd.Cells[1,34] := '';
  ValuesEd.Cells[1,35] := '';
  ValuesEd.Cells[1,36] := '';
  ValuesEd.Cells[1,37] := '';
  ValuesEd.Cells[1,38] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'items\3\';     //   
  ShablonsPath := Path+'shablons\items\3\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;



procedure TSinglItemsIdbR3F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;



procedure TSinglItemsIdbR3F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglItemsIdbR3F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Armor Type -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //Armor ID -  3  UnsLong.
  ValuesEd.Cells[1,3] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(3)));

  //Armor Material Type -  4  TEXT.
  ValuesEd.Cells[1,4] := PzDbStrToStr(Zap1.GetField(4));

  //Unknown1 -  5   ,  4  .
  Unknown1 := Zap1.GetField(5);
  Unk1Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,5] := GetUnkStr(Unknown1,Unk1Siz);

  //Graphics Data Texture Type Index -  6  UnsLong.
  ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(6)));

  //Graphics Data Texture Type Index2 -  7  UnsLong.
  ValuesEd.Cells[1,7] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(7)));

  //General Price -  8  FLOAT.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(8)),7));

  //General Weight -  9  FLOAT.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //General Size -  10  FLOAT.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(10)),7));

  //General Mana -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //General Slots -  12  UnsLong.
  ValuesEd.Cells[1,12] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(12)));

  //General Durability -  13  FLOAT.
  ValuesEd.Cells[1,13] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(13)),7));

  //General Components -  14  UnsLong.
  ValuesEd.Cells[1,14] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(14)));

  //ShopInfo -  15
  ValuesEd.Cells[1,15] := UnsLongToShopInfo(_4byteStrToUnsLong(Zap1.GetField(15)));

  //General Deconstructable -  16  UnsLong.
  ValuesEd.Cells[1,16] := BoolToStr(_1byteStrToBool(Zap1.GetField(16)));

  //Main -  17   -    , 9 FLOAT .
  BufSt := Zap1.GetField(17);
  //Main Absorption. FLOAT. -  1.
  ValuesEd.Cells[1,17] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Piercing. FLOAT. -  2.
  ValuesEd.Cells[1,18] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Slashing. FLOAT. -  3.
  ValuesEd.Cells[1,19] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Bludgeoning. FLOAT. -  4.
  ValuesEd.Cells[1,20] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Termal. FLOAT. -  5.
  ValuesEd.Cells[1,21] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Chemic. FLOAT. -  6.
  ValuesEd.Cells[1,22] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main Electric. FLOAT. -  7.
  ValuesEd.Cells[1,23] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Main General. FLOAT. -  8.
  ValuesEd.Cells[1,24] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Unknown2. FLOAT. -  9.
  ValuesEd.Cells[1,25] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Additional -  18   -    , 9 FLOAT .
  BufSt := Zap1.GetField(18);
  //Additional Absorption. FLOAT. -  1.
  ValuesEd.Cells[1,26] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Piercing. FLOAT. -  2.
  ValuesEd.Cells[1,27] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Slashing. FLOAT. -  3.
  ValuesEd.Cells[1,28] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Bludgeoning. FLOAT. -  4.
  ValuesEd.Cells[1,29] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Termal. FLOAT. -  5.
  ValuesEd.Cells[1,30] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Chemic. FLOAT. -  6.
  ValuesEd.Cells[1,31] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional Electric. FLOAT. -  7.
  ValuesEd.Cells[1,32] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Additional General. FLOAT. -  8.
  ValuesEd.Cells[1,33] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Unknown3. FLOAT. -  9.
  ValuesEd.Cells[1,34] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Graphics Data Apply Wounds -  19  BOOLEAN.
  ValuesEd.Cells[1,35] := BoolToStr(_1byteStrToBool(Zap1.GetField(19)));

  //Graphics Data Wear Order -  20  UnsLong.
  ValuesEd.Cells[1,36] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(20)));

  //Unknown4 -  21   ,  3  .
  Unknown4 := Zap1.GetField(21);
  Unk4Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,37] := GetUnkStr(Unknown4,Unk4Siz);

  //Unknown5 -  22   ,  4  .
  Unknown5 := Zap1.GetField(22);
  Unk5Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,38] := GetUnkStr(Unknown5,Unk5Siz);

end;

Function TSinglItemsIdbR3F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Armor ID
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end
  else begin
    // ID   Weapon Type.
    If ValuesEd.Cells[1,2] = 'helm' then ValuesEd.Cells[1,3] := IntToStr(0);
    If ValuesEd.Cells[1,2] = 'plate' then ValuesEd.Cells[1,3] := IntToStr(1);
    If ValuesEd.Cells[1,2] = 'leggings' then ValuesEd.Cells[1,3] := IntToStr(2);
    If ValuesEd.Cells[1,2] = 'shirt' then ValuesEd.Cells[1,3] := IntToStr(3);
    If ValuesEd.Cells[1,2] = 'pants' then ValuesEd.Cells[1,3] := IntToStr(4);
    If ValuesEd.Cells[1,2] = 'boots' then ValuesEd.Cells[1,3] := IntToStr(5);
    If ValuesEd.Cells[1,2] = 'gloves' then ValuesEd.Cells[1,3] := IntToStr(6);
  end;

  if CheckStrInt(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Graphics Data Texture Type Index
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Graphics Data Texture Type Index2
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //General Price
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //General Weight
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //General Size
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //General Mana
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //General Slots
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //General Durability
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //General Components
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckShopInfo(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //- 
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .      ,  ,      (   )';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //General Deconstructable
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Main Absorption
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Main Piercing
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,19]) = false then begin
    AllOk := false;
    //Main Slashing
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //Main Bludgeoning
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,21]) = false then begin
    AllOk := false;
    //Main Termal
    ValuesEd.Selection := SelGridRect(1,21);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,22]) = false then begin
    AllOk := false;
    //Main Chemic
    ValuesEd.Selection := SelGridRect(1,22);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,23]) = false then begin
    AllOk := false;
    //Main Electric
    ValuesEd.Selection := SelGridRect(1,23);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,24]) = false then begin
    AllOk := false;
    //Main General
    ValuesEd.Selection := SelGridRect(1,24);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,25]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,25);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,26]) = false then begin
    AllOk := false;
    //Additional Absorption
    ValuesEd.Selection := SelGridRect(1,26);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,27]) = false then begin
    AllOk := false;
    //Additional Piercing
    ValuesEd.Selection := SelGridRect(1,27);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,28]) = false then begin
    AllOk := false;
    //Additional Slashing
    ValuesEd.Selection := SelGridRect(1,28);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,29]) = false then begin
    AllOk := false;
    //Additional Bludgeoning
    ValuesEd.Selection := SelGridRect(1,29);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,30]) = false then begin
    AllOk := false;
    //Additional Termal
    ValuesEd.Selection := SelGridRect(1,30);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,31]) = false then begin
    AllOk := false;
    //Additional Chemic
    ValuesEd.Selection := SelGridRect(1,31);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,32]) = false then begin
    AllOk := false;
    //Additional Electric
    ValuesEd.Selection := SelGridRect(1,32);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,33]) = false then begin
    AllOk := false;
    //Additional General
    ValuesEd.Selection := SelGridRect(1,33);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,34]) = false then begin
    AllOk := false;
    //Unknown3
    ValuesEd.Selection := SelGridRect(1,34);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,35]) = false then begin
    AllOk := false;
    //Graphics Data Apply Wounds
    ValuesEd.Selection := SelGridRect(1,35);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,36]) = false then begin
    AllOk := false;
    //Graphics Data Wear Order
    ValuesEd.Selection := SelGridRect(1,36);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Armor Type.  2. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,2]);
    //  ...
    Zap1.ReWriteField(2,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Armor ID.  3. UnsLong.
    Zap1.ReWriteField(3,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,3])));

    //Armor Material Type.  4. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,4]);
    //  ...
    Zap1.ReWriteField(4,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Unknown1.  5.    .
    Zap1.ReWriteField(5,Unk1Siz,Unknown1);

    //Graphics Data Texture Type Index.  6. UnsLong.
    Zap1.ReWriteField(6,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,6])));

    //Graphics Data Texture Type Index2.  7. UnsLong.
    Zap1.ReWriteField(7,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,7])));

    //General Price.  8. FLOAT.
    Zap1.ReWriteField(8,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8])));

    //General Weight.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9])));

    //General Size.  10. FLOAT.
    Zap1.ReWriteField(10,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10])));

    //General Mana.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //General Slots.  12. UnsLong.
    Zap1.ReWriteField(12,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,12])));

    //General Durability.  13. FLOAT.
    Zap1.ReWriteField(13,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,13])));

    //General Components.  14. UnsLong.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,14])));

    //ShopInfo.  15.
    Zap1.ReWriteField(15,4,UnsLongTo4byteStr(ShopInfoToUnsLong(ValuesEd.Cells[1,15])));

    //General Deconstructable.  16. BOOLEAN.
    Zap1.ReWriteField(16,1,BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,16])));

    //Main.  17. 9 FLOAT .
    BufSt := '';
    //Main Absorption
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,17]));
    //Main Piercing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,18]));
    //Main Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,19]));
    //Main Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,20]));
    //Main Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,21]));
    //Main Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,22]));
    //Main Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,23]));
    //Main General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,24]));
    //Unknown2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,25]));
    Zap1.ReWriteField(17,36,BufSt);

    //Additional.  18. 9 FLOAT .
    BufSt := '';
    //Additional Absorption
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,26]));
    //Additional Piercing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,27]));
    //Additional Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,28]));
    //Additional Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,29]));
    //Additional Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,30]));
    //Additional Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,31]));
    //Additional Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,32]));
    //Additional General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,33]));
    //Unknown3
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,34]));
    Zap1.ReWriteField(18,36,BufSt);

    //Graphics Data Apply Wounds.  19. BOOLEAN.
    Zap1.ReWriteField(19,1,BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,35])));

    //Graphics Data Wear Order.  20. UnsLong.
    Zap1.ReWriteField(20,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,36])));

    //Unknown4.  21.    .
    Zap1.ReWriteField(21,Unk4Siz,Unknown4);

    //Unknown5.  22.    .
    Zap1.ReWriteField(22,Unk5Siz,Unknown5);

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglItemsIdbR3F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[4].EditStyle := esEllipsis;
    ValuesEd.ItemProps[36].EditStyle := esEllipsis;
    ValuesEd.ItemProps[37].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglItemsIdbR3F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[4].EditStyle := esSimple;
    ValuesEd.ItemProps[36].EditStyle := esSimple;
    ValuesEd.ItemProps[37].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglItemsIdbR3F.MaskiBox.Items.Capacity-1 do begin
    If SinglItemsIdbR3F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglItemsIdbR3F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglItemsIdbR3F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;



procedure TSinglItemsIdbR3F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;  
end;



procedure TSinglItemsIdbR3F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;



procedure TSinglItemsIdbR3F.CloseButClick(Sender: TObject);
begin
  Close;
end;



procedure TSinglItemsIdbR3F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;



procedure TSinglItemsIdbR3F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglItemsIdbR3F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 5 then begin
      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := Unk1Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          Unk1Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,5] := GetUnkStr(Unknown1,Unk1Siz);
        end;
      end;
    end;
       
    If ValuesEd.Row = 37 then begin
      //4, 3  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown4;
      UncAskF.UncAskFBytes := Unk4Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown4 := UncAskF.UncAskFBuff;
          Unk4Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,37] := GetUnkStr(Unknown4,Unk4Siz);
        end;
      end;
    end;

    If ValuesEd.Row = 38 then begin
      //5, 8  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown5;
      UncAskF.UncAskFBytes := Unk5Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown5 := UncAskF.UncAskFBuff;
          Unk5Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,38] := GetUnkStr(Unknown5,Unk5Siz);
        end;
      end;
    end;

  end;
end;

procedure TSinglItemsIdbR3F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
