///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglSpellsSdbR2Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglSpellsSdbR2F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglSpellsSdbR2F: TSinglSpellsSdbR2F;
  PathForForm, MaskaNam, FileNam, ShablonsPath : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglSpellsSdbR2F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglSpellsSdbR2FClosed := true;
  MainForm.SpellsMenu2.Checked := false;
  Action := CaFree;
end;

procedure TSinglSpellsSdbR2F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglSpellsSdbR2FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'spells\2\';     //   
  ShablonsPath := Path+'shablons\spells\2\';  //  
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglSpellsSdbR2F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglSpellsSdbR2F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglSpellsSdbR2F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Code -  2  4bTEXT.
  ValuesEd.Cells[1,2] := _4byteStrWth4bTEXT_ToStr(Zap1.GetField(2));

  //Price -  3  FLOAT.
  ValuesEd.Cells[1,3] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(3)),7));

  //TypeID -  4  UnsLong. - ID.  -...
  BufSt :=  IntToStr(_4byteStrToUnsLong(Zap1.GetField(4)));
  If BufSt = '0' then begin
    BufSt := BufSt+'     RANGE';
  end;
  If BufSt = '1' then begin
    BufSt := BufSt+'     TARGETS';
  end;
  If BufSt = '2' then begin
    BufSt := BufSt+'     AREA';
  end;
  If BufSt = '3' then begin
    BufSt := BufSt+'     EFFECT';
  end;
  If BufSt = '4' then begin
    BufSt := BufSt+'     DURATION';
  end;
  If BufSt = '5' then begin
    BufSt := BufSt+'     MANA';
  end;
  If BufSt = '6' then begin
    BufSt := BufSt+'     FILTER';
  end;
  If BufSt = '7' then begin
    BufSt := BufSt+'     ITEM';
  end;
  ValuesEd.Cells[1,4] := BufSt;

  //Mana -  5  FLOAT.
  ValuesEd.Cells[1,5] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(5)),7));

  //Value -  6  FLOAT.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //Complex -  7  UnsLong.
  ValuesEd.Cells[1,7] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(7)));

  //Shop -  8  TEXT.
  ValuesEd.Cells[1,8] := PzDbStrToStr(Zap1.GetField(8));

  //ShopInfo -  9
  ValuesEd.Cells[1,9] := UnsLongToShopInfo(_4byteStrToUnsLong(Zap1.GetField(9)));

end;

Function TSinglSpellsSdbR2F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStr4bTEXT(ValuesEd.Cells[1,2]) = false then begin
    AllOk := false;
    //Code
    ValuesEd.Selection := SelGridRect(1,2);
    ErrorMsgStr := '    .   4  (),    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Price
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(FilterValue(ValuesEd.Cells[1,4])) = false then begin
    AllOk := false;
    //TypeID.    !!!
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //Mana
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Value
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Complex
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckShopInfo(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //- 
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .      ,  ,      (   )';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //Code.  2. 4bTEXT.
    BufSt := StrTo4bTEXT(ValuesEd.Cells[1,2]);
    Zap1.ReWriteField(2,Length(BufSt),BufSt);

    //Price.  3. FLOAT.
    Zap1.ReWriteField(3,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,3])));

    //TypeID.  4. UnsLong.    .
    Zap1.ReWriteField(4,4,UnsLongTo4byteStr(StrToInt(FilterValue(ValuesEd.Cells[1,4]))));

    //Mana.  5. FLOAT.
    Zap1.ReWriteField(5,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,5])));

    //Value.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //Complex.  7. UnsLong.
    Zap1.ReWriteField(7,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,7])));

    //Shop.  8. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,8]);
    Zap1.ReWriteField(8,Length(BufSt),BufSt);

    //ShopInfo.  9.
    Zap1.ReWriteField(9,4,UnsLongTo4byteStr(ShopInfoToUnsLong(ValuesEd.Cells[1,9])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglSpellsSdbR2F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[3].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglSpellsSdbR2F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[3].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglSpellsSdbR2F.MaskiBox.Items.Capacity-1 do begin
    If SinglSpellsSdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglSpellsSdbR2F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglSpellsSdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSinglSpellsSdbR2F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglSpellsSdbR2F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglSpellsSdbR2F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglSpellsSdbR2F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglSpellsSdbR2F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglSpellsSdbR2F.ValuesEdEditButtonClick(Sender: TObject);
var
  BufSt : string;
  Idx : Integer;
  
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin

    If ValuesEd.Row = 4 then begin
      //       ...
      //  -  ...
      Idx := 0; //  ....
      If FilterValue(ValuesEd.Cells[1,4]) = '0' then begin
        Idx := 0;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '1' then begin
        Idx := 1;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '2' then begin
        Idx := 2;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '3' then begin
        Idx := 3;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '4' then begin
        Idx := 4;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '5' then begin
        Idx := 5;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '6' then begin
        Idx := 6;
      end;
      If FilterValue(ValuesEd.Cells[1,4]) = '7' then begin
        Idx := 7;
      end;
      BufSt := SelectValueEx('0     RANGE'+#13+'1     TARGETS'+#13+'2     AREA'+#13+'3     EFFECT'+#13+'4     DURATION'+#13+'5     MANA'+#13+'6     FILTER'+#13+'7     ITEM'+#13,Idx);
      If BufSt <> #13 then begin
        //    ...
        ValuesEd.Cells[1,4] := BufSt;
      end;
    end;

  end;
end;

procedure TSinglSpellsSdbR2F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
