///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglUnitsUdbR4Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglUnitsUdbR4F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglUnitsUdbR4F: TSinglUnitsUdbR4F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglUnitsUdbR4F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglUnitsUdbR4FClosed := true;
  MainForm.UnitsMenu4.Checked := false;
  Action := CaFree;
end;

procedure TSinglUnitsUdbR4F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglUnitsUdbR4FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'units\4\';     //   
  ShablonsPath := Path+'shablons\units\4\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglUnitsUdbR4F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglUnitsUdbR4F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglUnitsUdbR4F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Unknown1 -  2   ,  4  .
  Unknown1 := Zap1.GetField(2);
  Unk1Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,2] := GetUnkStr(Unknown1,Unk1Siz);

  //Exp -  3  FLOAT.
  ValuesEd.Cells[1,3] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(3)),7));

  //Strength -  4  FLOAT.
  ValuesEd.Cells[1,4] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(4)),7));

  //Dexterity -  5  FLOAT.
  ValuesEd.Cells[1,5] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(5)),7));

  //Intelligence -  6  FLOAT.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //SST -  7   -    , 3 BYTE .
  BufSt := Zap1.GetField(7);
  //Science. BYTE. -  1.
  ValuesEd.Cells[1,7] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Stealing. BYTE. -  2.
  ValuesEd.Cells[1,8] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Tame. BYTE. -  3.
  ValuesEd.Cells[1,9] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));

  //MABESASA -  8   -    , 8 BYTE .
  BufSt := Zap1.GetField(8);
  //Melee. BYTE. -  1.
  ValuesEd.Cells[1,10] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Archery. BYTE. -  2.
  ValuesEd.Cells[1,11] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Backstab. BYTE. -  3.
  ValuesEd.Cells[1,12] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Elemental. BYTE. -  4.
  ValuesEd.Cells[1,13] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Senses. BYTE. -  5.
  ValuesEd.Cells[1,14] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Astral. BYTE. -  6.
  ValuesEd.Cells[1,15] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Stealth. BYTE. -  7.
  ValuesEd.Cells[1,16] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));
  //Awareness. BYTE. -  8.
  ValuesEd.Cells[1,17] := IntToStr(Integer(_1byteStrToByte(OtkusitStrokeBashku(@BufSt,1))));

  //Perks -  9  List.
  ValuesEd.Cells[1,18] := ListToStr(Zap1.GetField(9));

  //Weapons -  10  List.
  ValuesEd.Cells[1,19] := ListToStr(Zap1.GetField(10));

  //QItems -  11  List.
  ValuesEd.Cells[1,20] := ListToStr(Zap1.GetField(11));

  //Spells -  12  List.
  ValuesEd.Cells[1,21] := ListToStr(Zap1.GetField(12));

  //Exp To Distribute -  13  FLOAT.
  ValuesEd.Cells[1,22] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(13)),7));

  //Money -  14  UnsLong.
  ValuesEd.Cells[1,23] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(14)));

  //Unknown2 -  15  BYTE.
  ValuesEd.Cells[1,24] := IntToStr(Integer(_1byteStrToByte(Zap1.GetField(15))));

end;

Function TSinglUnitsUdbR4F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Exp
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Strength
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //Dexterity
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Intelligence
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Science
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //Stealing
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //Tame
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Melee
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Archery
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Backstab
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Elemental
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Senses
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Astral
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Stealth
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Awareness
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  if CheckList(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Perks
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,18] := ListBezProbelov(ValuesEd.Cells[1,18]);
    if CheckList(ValuesEd.Cells[1,18]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,18);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,19]) = false then begin
    AllOk := false;
    //Weapons
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,19] := ListBezProbelov(ValuesEd.Cells[1,19]);
    if CheckList(ValuesEd.Cells[1,19]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,19);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //QItems
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,20] := ListBezProbelov(ValuesEd.Cells[1,20]);
    if CheckList(ValuesEd.Cells[1,20]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,20);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,21]) = false then begin
    AllOk := false;
    //Spells
    ValuesEd.Selection := SelGridRect(1,21);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,21] := ListBezProbelov(ValuesEd.Cells[1,21]);
    if CheckList(ValuesEd.Cells[1,21]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,21);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,22]) = false then begin
    AllOk := false;
    //Exp To Distribute
    ValuesEd.Selection := SelGridRect(1,22);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,23]) = false then begin
    AllOk := false;
    //Money
    ValuesEd.Selection := SelGridRect(1,23);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrByte(ValuesEd.Cells[1,24]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,24);
    ErrorMsgStr := '    .   255    -128 (1 )';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //Unknown1.  2.    .
    Zap1.ReWriteField(2,Unk1Siz,Unknown1);

    //Exp.  3. FLOAT.
    Zap1.ReWriteField(3,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,3])));

    //Strength.  4. FLOAT.
    Zap1.ReWriteField(4,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,4])));

    //Dexterity.  5. FLOAT.
    Zap1.ReWriteField(5,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,5])));

    //Intelligence.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //SST.  7. 3 BYTE .
    BufSt := '';
    //Science
    BufSt := ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,7])));
    //Stealing
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,8])));
    //Tame
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,9])));
    Zap1.ReWriteField(7,3,BufSt);

    //SST.  8. 8 BYTE .
    BufSt := '';
    //Melee
    BufSt := ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,10])));
    //Archery
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,11])));
    //Backstab
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,12])));
    //Elemental
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,13])));
    //Senses
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,14])));
    //Astral
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,15])));
    //Stealth
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,16])));
    //Awareness
    BufSt := BufSt+ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,17])));
    Zap1.ReWriteField(8,8,BufSt);

    //Perks.  9. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,18]);
    Zap1.ReWriteField(9,Length(BufSt),BufSt);

    //Weapons.  10. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,19]);
    Zap1.ReWriteField(10,Length(BufSt),BufSt);

    //QItems.  11. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,20]);
    Zap1.ReWriteField(11,Length(BufSt),BufSt);

    //Spells.  12. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,21]);
    Zap1.ReWriteField(12,Length(BufSt),BufSt);

    //Exp To Distribute.  13. FLOAT.
    Zap1.ReWriteField(13,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,22])));

    //Money.  14. UnsLong.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,23])));

    //Unknown2.  15. BYTE.
    Zap1.ReWriteField(15,1,ByteTo1byteStr(Byte(StrToInt(ValuesEd.Cells[1,24]))));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglUnitsUdbR4F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[1].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglUnitsUdbR4F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[1].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglUnitsUdbR4F.MaskiBox.Items.Capacity-1 do begin
    If SinglUnitsUdbR4F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglUnitsUdbR4F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglUnitsUdbR4F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSinglUnitsUdbR4F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglUnitsUdbR4F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglUnitsUdbR4F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglUnitsUdbR4F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglUnitsUdbR4F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglUnitsUdbR4F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin

    If ValuesEd.Row = 2 then begin
      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := Unk1Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          Unk1Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,2] := GetUnkStr(Unknown1,Unk1Siz);
        end;
      end;
    end;

  end;
end;

procedure TSinglUnitsUdbR4F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
