///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit UnitsUdbR1Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TUnitsUdbR1F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  UnitsUdbR1F: TUnitsUdbR1F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TUnitsUdbR1F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  UnitsUdbR1FClosed := true;
  MainForm.LmpUnitsMenu1.Checked := false;
  Action := CaFree;
end;

procedure TUnitsUdbR1F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  UnitsUdbR1FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'units\1\';     //   
  ShablonsPath := Path+'shablons\units\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TUnitsUdbR1F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TUnitsUdbR1F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TUnitsUdbR1F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //FirstGroup -  2   -    , 7 FLOAT .
  BufSt := Zap1.GetField(2);
  //Physical Piercing. FLOAT. -  1.
  ValuesEd.Cells[1,2] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Physical Slashing. FLOAT. -  2.
  ValuesEd.Cells[1,3] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Physical Bludgeoning. FLOAT. -  3.
  ValuesEd.Cells[1,4] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Termal. FLOAT. -  4.
  ValuesEd.Cells[1,5] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Chemic. FLOAT. -  5.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Electric. FLOAT. -  6.
  ValuesEd.Cells[1,7] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Other General. FLOAT. -  7.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Second Group -  3   -    , 7 FLOAT .
  BufSt := Zap1.GetField(3);
  //Physical Piercing2. FLOAT. -  1.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Physical Slashing2. FLOAT. -  2.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Physical Bludgeoning2. FLOAT. -  3.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Termal2. FLOAT. -  4.
  ValuesEd.Cells[1,12] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Chemic2. FLOAT. -  5.
  ValuesEd.Cells[1,13] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Elemental Electric2. FLOAT. -  6.
  ValuesEd.Cells[1,14] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Other General2. FLOAT. -  7.
  ValuesEd.Cells[1,15] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Unknown1 -  4  UnsLong.
  ValuesEd.Cells[1,16] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(4)));
  //Unknown2 -  5  UnsLong.
  ValuesEd.Cells[1,17] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(5)));
end;

Function TUnitsUdbR1F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,2]) = false then begin
    AllOk := false;
    //Physical Piercing
    ValuesEd.Selection := SelGridRect(1,2);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Physical Slashing
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Physical Bludgeoning
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //Elemental Termal
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Elemental Chemic
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Elemental Electric
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //Other | General
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //Physical Piercing2
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Physical Slashing2
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Physical Bludgeoning2
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Elemental Termal2
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Elemental Chemic2
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Elemental Electric2
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Other | General2
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Unknown1
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //First Group.  2. 7 FLOAT .
    BufSt := '';
    //Physical Piercing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,2]));
    //Physical Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,3]));
    //Physical Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,4]));
    //Elemental Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,5]));
    //Elemental Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6]));
    //Elemental Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,7]));
    //Other General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8]));
    Zap1.ReWriteField(2,28,BufSt);

     //Second Group.  3. 7 FLOAT .
    BufSt := '';
    //Physical Piercing2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9]));
    //Physical Slashing2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10]));
    //Physical Bludgeoning2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11]));
    //Elemental Termal2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,12]));
    //Elemental Chemic2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,13]));
    //Elemental Electric2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,14]));
    //Other General2
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,15]));
    Zap1.ReWriteField(3,28,BufSt);

    //Unknown1.  4. UnsLong.
    Zap1.ReWriteField(4,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,16])));

     //Unknown2.  5. UnsLong.
    Zap1.ReWriteField(5,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,17])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TUnitsUdbR1F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    TableActivated := true;
  end;
end;

Procedure TUnitsUdbR1F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to UnitsUdbR1F.MaskiBox.Items.Capacity-1 do begin
    If UnitsUdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to UnitsUdbR1F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If UnitsUdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TUnitsUdbR1F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TUnitsUdbR1F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TUnitsUdbR1F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TUnitsUdbR1F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TUnitsUdbR1F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TUnitsUdbR1F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin

  end;
end;

procedure TUnitsUdbR1F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
